function Generador_variosModenserie_distintosMuestras(modenserie,Pnom)

%UTILIDAD:
    
    %Calcula la pot. nominal, la de trabajo, la suma de Pot. maximas y las perdidas por dispersion y totales de varios
           %seguidores con difeente n de modulos en serie y 4 serie.Y de algunos de sus modulos.
           %Dibuja las curvas de los modulos que forman los generadores simulados, sus PMP y los puntos de trebajo de algunos de ellos.

%VARIABLES DE ENTRADA:
    %modenserie: vector con los numeros de mdulos en serie que se desea simular.
    %Pnom: potencia nominal de los modulos utilizados.
    
warning off

%Lee los datos de los (36) modulos diferentes, creados medinte muestras aleatorias en nuestro caso. Para ello usamos la funcion curvaIVmodulos.

[V,I]= curvaIVnmodulos;

%Duplicamos el n de modulos disponibles cogiendo cad uno de ellos dos veces. En nuestro caso tendramos 72.
mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

%Duplica el n de modulos de nuevo dos veces ms. Tendriamos 288 mdulos disponibles (36 repetidos 8 veces cada uno) 
mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

%Calcula la potencia en los puntos de la curva de cada mdulo.
for i=1:size(V,1)
    for t=1:size(V,2)
        P(i,t)=V(i,t)*I(i,t);
    end
end

%Dibuja las curvas de los modulos para una configuracion 9sx4p. y sus puntos de maxima potencia.

% figure
% for i=1:36
%     hold on
%     plot(V(i,:),I(i,:));
%     for t=1:size(P,2)
%         if P(i,t)==max(P(i,:))
%             lugar(i)=t;
%         end
%     end
%     plot(V(i,lugar(i)),I(i,lugar(i)),'k*');
%     xlabel('Tensin (V)');
% 	ylabel('Corriente (A)');
%     title('9sx4p');
% end


%Calcula la potencia de trabajo, la nominal y la suma de potencias maximas para 
    %cada una de las configuraciones (cada una con 4 series y diferente n de modulos en serie)

for i=1:length(modenserie)
    
       [Vsinc{i} Isinc{i} Vser{i} Iser{i}]= calculoseguidor2(V(1:modenserie(i)*4,:),I(1:modenserie(i)*4,:),4,modenserie(i),(1:modenserie(i)*4));
       
       for p=1:length(Vsinc{i})
           
           Psinc{i}(1,p)=Vsinc{i}(1,p)*Isinc{i}(1,p);
           
           if Psinc{i}(1,p)==max(Psinc{i}(1,:))
               lugarGEN(i)=p;
           end
       end
       
       PsincMAX(i)=max(Psinc{i}); %Potencia mxima de cad generador.
       Pideal(i)=Pnom*modenserie(i)*4;%Potencia nominal de cada generador.
      
end

%Calcula la suma de potencias maximas de los modulos de cada generador.
for i=1:length(modenserie)
    Psuma_de_maximas(i)=0;
    for p=1:4*modenserie(i)
        Psuma_de_maximas(i)=Psuma_de_maximas(i)+ max(P(p,:));
    end
end



%Calcula la potencia de trabajo de los 5 primeros modulos de cada configuracion con 4 series o con 4 modulos en serie.
    %calcula la corriente de cada serie.
for t=1:5
    for i=1:length(modenserie)
        if t<=modenserie(i) 
            
            [Iseriereal{t}(i)]=extrapola2ju(Vser{i}(1,:),Iser{i}(1,:),Vsinc{i}(1,lugarGEN(i)));
            [Vmodmoden{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
            Pmodmoden{t}(i)=Vmodmoden{t}(i)*Iseriereal{t}(i);
            
        elseif modenserie(i)<=t && t<=modenserie(i)*2
            
           [Iseriereal{t}(i)]=extrapola2ju(Vser{i}(2,:),Iser{i}(2,:),Vsinc{i}(1,lugarGEN(i)));
            [Vmodmoden{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
            Pmodmoden{t}(i)=Vmodmoden{t}(i)*Iseriereal{t}(i);
            
        elseif (modenserie(i)*2)<=t  &&  t<=modenserie(i)*3
            
            [Iseriereal{t}(i)]=extrapola2ju(Vser{i}(3,:),Iser{i}(3,:),Vsinc{i}(1,lugarGEN(i)));
            [Vmodmoden{t}(i)]=extrapola2ju(I(t,:),V(t,:),Iseriereal{t}(i));
            Pmodmoden{t}(i)=Vmodmoden{t}(i)*Iseriereal{t}(i);
        end
        
    end
end
 
%Calcula la potencia de trabajo de los 5 modulos (1 5 10 13 16)de cada configuracion con 4 series o con 4 modulos en serie.
    %calcula la corriente de cada serie.
modulos=[6 8 12 14 16];
for t=1:length(modulos)
    for i=1:length(modenserie)
       ser=fix(modulos(t)/modenserie(i));
       if fix(modulos(t)/modenserie(i))==modulos(t)/modenserie(i)
       else
           ser=ser+1;
       end
            
            [Iseriereal{modulos(t)}(i)]=extrapola2ju(Vser{i}(ser,:),Iser{i}(ser,:),Vsinc{i}(1,lugarGEN(i)));
            [Vmodmoden{modulos(t)}(i)]=extrapola2ju(I(modulos(t),:),V(modulos(t),:),Iseriereal{modulos(t)}(i));
            Pmodmoden{modulos(t)}(i)=Vmodmoden{modulos(t)}(i)*Iseriereal{modulos(t)}(i);
    end
end

%Dibuja los puntos de trabajo de los 5 primeros modulos por separado y para cada n de modulos en serie. 
%for t=1:length(modenserie)
%    figure
%    hold on
%    for i=1:5
%        plot(V(i,:),I(i,:));
%        plot(V(i,lugar(i)),I(i,lugar(i)),'k*');
%        plot(Vmodmoden{i}(t),Iseriereal{i}(t),'ro');
%    end
%    xlabel('Tensin (V)');
%	ylabel('Corriente (A)');
%     title([num2str(modenserie(t)),'sx4p 5 PRIMEROS']);
%end

%Dibuja los puntos de trabajo de 5 modulos por separado y para cada n de modulos en serie. 
%for t=1:length(modenserie)
%    figure
%    hold on
%   for i=1:length(modulos)
%        plot(V(modulos(i),:),I(modulos(i),:));
%        plot(V(modulos(i),lugar(modulos(i))),I(modulos(i),lugar(modulos(i))),'k*');
%        plot(Vmodmoden{modulos(i)}(t),Iseriereal{modulos(i)}(t),'ro');
%    end
%    xlabel('Tensin (V)');
%	ylabel('Corriente (A)');
%     title([num2str(modenserie(t)),'sx4p 1 5 10 13 16']);
%end

%PRUEBA: dibuja los 8 primeros modulos, distinguiendo el 1 y el 8 para ver como son en cada n de modulos en serie.
% for t=1:length(modenserie)
%     figure
%     hold on
%     for i=1:8
%         if i==1
%             plot(V(i,:),I(i,:),'r');
%         elseif i==8
%             plot(V(i,:),I(i,:),'k');
%         else
%             plot(V(i,:),I(i,:));
%         end
%         if i==7
%         else
%             plot(V(i,lugar(i)),I(i,lugar(i)),'k*');
%             plot(Vmodmoden{i}(t),Iseriereal{i}(t),'ro');
%         end
%     end
% end




%Pone en una hoja excel las perdidas totales y las perdidas por dispersion para diferente n de modulos en serie y 4 series.
    %Las prdidas de cada generador, y de algunos de sus mdulos.
    
celda{1,5}='PRDIDAS POR DISPERSIN';
celda{1,6}='PRDIDAS TOTALES';

celda{2,2}='?Pmax. sin defecto';
celda{2,3}='?Pmax. con defecto';
celda{2,4}='P.de trabajo';
celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';

celda{3,1}='GENERADORES';
for i=1:length(modenserie)
    celda{3+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end
celda{17,1}='Modulo 1';
for i=1:length(modenserie)
    celda{17+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{31,1}='Modulo 2';
for i=1:length(modenserie)
    celda{31+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{45,1}='Modulo 3';
for i=1:length(modenserie)
    celda{45+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{59,1}='Modulo 4';
for i=1:length(modenserie)
    celda{59+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{73,1}='Modulo 5';
for i=1:length(modenserie)
    celda{73+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 

celda{87,1}='Modulo 1';
for i=1:length(modenserie)
    celda{87+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{101,1}='Modulo 5';
for i=1:length(modenserie)
    celda{101+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{115,1}='Modulo 10';
for i=1:length(modenserie)
    celda{115+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{129,1}='Modulo 13';
for i=1:length(modenserie)
    celda{129+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 
celda{143,1}='Modulo 16';
for i=1:length(modenserie)
    celda{143+i,1}=[num2str(modenserie(i)),'modulos en serie.'];
end 


%Pone los datos de cada generador.
for i=1:length(modenserie)
    celda{3+i,2}=Pideal(i);
    celda{3+i,3}=Psuma_de_maximas(i);
    celda{3+i,4}= PsincMAX(i);
    celda{3+i,5}=(celda{3+i,3}-celda{3+i,4})/celda{3+i,2};
    celda{3+i,6}=(celda{3+i,2}-celda{3+i,4})/celda{3+i,2};
end

%Pone los datos de diferentes mdulos de cada generador. En cada uno el modulo ocupa diferente lugar y comparte generador con diferentes modulos.

v=[17 31 45 59 73];
for i=1:length(v)
    for t=1:length(modenserie)
        comienzo=v(i);
        celda{comienzo+t,2}=Pnom;
        celda{comienzo+t,3}=max(P(i,:));
        celda{comienzo+t,4}=Pmodmoden{i}(t);
        celda{comienzo+t,5}=(celda{comienzo+t,3}-celda{comienzo+t,4})/celda{comienzo+t,2};
        celda{comienzo+t,6}=(celda{comienzo+t,2}-celda{comienzo+t,4})/celda{comienzo+t,2};
    end
end

v=[87 101 115 129 143];
for i=1:length(v)
    for t=1:length(modenserie)
        comienzo=v(i);
        celda{comienzo+t,2}=Pnom;
        celda{comienzo+t,3}=max(P(modulos(i),:));
        celda{comienzo+t,4}=Pmodmoden{modulos(i)}(t);
        celda{comienzo+t,5}=(celda{comienzo+t,3}-celda{comienzo+t,4})/celda{comienzo+t,2};
        celda{comienzo+t,6}=(celda{comienzo+t,2}-celda{comienzo+t,4})/celda{comienzo+t,2};
    end
end

nombre_hoja='modenserie MODULOS DISTINTOS';
rango='A1';
xlswrite(('C:\Users\usuario\Desktop\pfc\pfc\DISTINTOS_MODSER'),celda,nombre_hoja,rango);
    
end
