function Generadores_9sx4p_def(Dsegui,segui,LETRA)

%UTILIDAD:
    %dibuja la curva I-V y P-V de los modulos de un seguidor 9sx4p(modulo def., mosma serie y resto)(todos iguales menos uno) y sus PMP y de trabajo.
    %Y calcula la pot. nominal, la de trabajo, la suma de Pot. maximas y las perdidas por dispersion y totales de cada mod. y del seguidor.


%VARIABLES DE ENTRADA:
    %Dsegui: se crea mediante la funcin "crearD". Es una variable que tiene los datos del la hoja excel donde hay 4 hojas de datos de 4 modulos (tres iguales y uno con defecto).
    %LETRA: es el nombre,letra o nmero con el que se desee asignar al generador simulado.
    %segui: es el nombre de la subcarpeta que se encuentra dentro de la carpeta "para matlab", en la que estan los datos a utilizar. 
    
warning off

%Lee los datos del modulo defectuoso y del perfecto.

nombredatos=Dsegui(1).name;
cont=1;

for i=1:2
nombre=['Modulo',num2str(cont)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:length(N),:);

V(:,i)=N(:,1);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I(:,i)=N(:,2);

cont=4; %para que lea los datos de la hoja "Modulo4", es decir, el defectuoso.
end

Vtot=V';
Itot=I';

%Calcula la potencia para cada punto de las curvas de los modulos.
%Y los valores de V y I en el punto de maxima potencia de cada modulo (del defectuoso y de los dems)

for i=1:size(Vtot,2)
    PtotPER(i)=Vtot(1,i)*Itot(1,i);
    PtotPER30(i)=(Vtot(1,i)*Itot(1,i))/30;
    if PtotPER(i)==max(PtotPER)
        VperMAX=Vtot(1,i);
        IperMAX=Itot(1,i);
    end
    PtotDEF(i)=Vtot(2,i)*Itot(2,i);
    PtotDEF30(i)=(Vtot(2,i)*Itot(2,i))/30;
    if PtotDEF(i)==max(PtotDEF)
        VdefMAX=Vtot(2,i);
        IdefMAX=Itot(2,i);
    end
end

%Calcula la potencia nominal del modulo (en nuestro caso no es la del fabricante, sino la maxima de los modulos perfectos)
Pnom=max(PtotPER);

%Dibuja las curvas I-V y P-V de los modulos (modulo defectuoso y la del resto).
%Y sus puntos de maxima potencia.
figure
hold on
plot(Vtot(1,:),Itot(1,:),'b');
plot(Vtot(2,:),Itot(2,:),'r');
plot(VperMAX,IperMAX,'b*');
plot(VdefMAX,IdefMAX,'b*');
plot(Vtot(1,:),PtotPER30,'b--');
plot(Vtot(2,:),PtotDEF30,'r--');
plot(VperMAX,max(PtotPER)/30,'b*');
plot(VdefMAX,max(PtotDEF)/30,'b*');


%HALLA LA V Y LA I DEL SEGUIDOR.

%Crea una matriz con los datos de cada uno de los 36 modulos del seguidor para poder utilizar la funcion calculoseguidor2

for i=1:36
    if i==36
        Vmod(i,:)=Vtot(2,:);
        Imod(i,:)=Itot(2,:);
    else
        Vmod(i,:)=Vtot(1,:);
        Imod(i,:)=Itot(1,:);
    end
end

%Calcula la V y I del generador y de sus series.
[Vsegui Isegui Vser Iser]= calculoseguidor2(Vmod,Imod,4,9,(1:36));

%Calcula la potencia en KW del generador en cada punto der la curva. Y la V y la I en el PMP.

for i=1:length(Vsegui)
    PseguiKW(i)=(Vsegui(1,i)*Isegui(1,i))/1000;
    
    if PseguiKW(i)==max(PseguiKW)
       
        VseguiREAL=Vsegui(1,i);
        IseguiREAL=Isegui(1,i);
    end
end


%Calcula la corriente que pasa por cada serie.
for i=1:4
[IserieREAL(i)]=extrapola2ju(Vser(i,:),Iser(i,:),VseguiREAL);
end

%calcula el punto de trabajo de cada tipo de modulos.
[VmodDEFreal]=extrapola2ju(Itot(2,:),Vtot(2,:),IserieREAL(4));
[VmodMISMAreal]=extrapola2ju(Itot(1,:),Vtot(1,:),IserieREAL(4));
[VmodRESTOreal]=extrapola2ju(Itot(1,:),Vtot(1,:),IserieREAL(1));

%Dibuja el punto de trabajo de cad tipo de modulo.
plot(VmodDEFreal,IserieREAL(4),'ro');
plot(VmodMISMAreal,IserieREAL(4),'ko');
plot(VmodRESTOreal,IserieREAL(1),'bo');
xlabel('Tensin (V)');
ylabel('Corriente(A)- Potencia(W/30)');
title(['GENERADOR "',LETRA,'"']);

%Calcula las perdidas por dispersion en el modulo defectuoso.
    %Calcula la potencia de trabajo de def.
    [PmodDEFreal]=extrapola2ju(Vtot(2,:),PtotDEF,VmodDEFreal);%Es otra forma de hacerlo. La diferencia es peuqea, no se cual es mas exacta.
    PmodDEFreal=VmodDEFreal*IserieREAL(4);
    
PER_DISdef=(max(PtotDEF)-PmodDEFreal)/(Pnom);
PER_TOTdef=(max(PtotPER)-PmodDEFreal)/(Pnom);

%Calcula las perdidas por dispersion en los modulos de la misma serie que el defectuoso.
    %calcula la potencia de trabajo de mod. misma serie.
    [PmodMISMAreal]=extrapola2ju(Vtot(1,:),PtotPER,VmodMISMAreal);%Es otra forma de hacerlo. La diferencia es peuqea, no se cual es mas exacta.
     PmodMISMAreal=VmodMISMAreal*IserieREAL(4); 
    
PER_DISmisma=(max(PtotPER)-PmodMISMAreal)/(Pnom);    

%Calcula las perdidas por dispersion en resto de modulos.
    %calcula la potencia de trabajo de resto de modulos.
    [PmodRESTOreal]=extrapola2ju(Vtot(1,:),PtotPER,VmodRESTOreal);%Es otra forma de hacerlo. La diferencia es peuqea, no se cual es mas exacta.
     PmodRESTOreal=VmodRESTOreal*IserieREAL(1);
    
PER_DISresto=(max(PtotPER)-PmodRESTOreal)/(Pnom); 

%Calcula las perdidas por dipersion y las totales, la porencia nom. la de trabajo y la suma de pot. maximas en el seguidor.
Pmax_sindef2=Pnom*9*4;
Pmax_condef2=Pnom*35+max(PtotDEF);
PotGENreal=max(PseguiKW);

PER_DISseguidor=(Pnom*35+max(PtotDEF)-(max(PseguiKW)*1000))/(Pnom*9*4);
PER_DISseguidor2=(max(PtotPER)*35+max(PtotDEF)-(max(PseguiKW)*1000))/(Pnom*9*4);

PER_TOTseguidor2=(Pmax_sindef2-(max(PseguiKW)*1000))/(Pnom*9*4);

%Pone los resultados en una celda para pasarlo a excel.
celda{1,5}='PRDIDAS POR DISPERSIN';
celda{1,6}='PRDIDAS TOTALES';

celda{2,2}='?Pmax. sin defecto';
celda{2,3}='?Pmax. con defecto';
celda{2,4}='P.de trabajo';
celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';

celda{3,1}=['Generador',LETRA];
celda{3,2}=Pmax_sindef2;
celda{3,3}=Pmax_condef2;
celda{3,4}=max(PseguiKW)*1000;
celda{3,5}=PER_DISseguidor2;
celda{3,6}=PER_TOTseguidor2;

celda{5,1}=['Mdulo defectuoso'];
celda{5,2}=max(PtotPER);
celda{5,3}=max(PtotDEF);
celda{5,4}=PmodDEFreal;
celda{5,5}=PER_DISdef;
celda{5,6}=PER_TOTdef;

celda{7,1}=['Mdulos misma serie'];
celda{7,2}=max(PtotPER);
celda{7,3}=max(PtotPER);
celda{7,4}=PmodMISMAreal;
celda{7,5}=PER_DISmisma;

celda{9,1}=['Resto de mdulos'];
celda{9,2}=max(PtotPER);
celda{9,3}=max(PtotPER);
celda{9,4}=PmodRESTOreal;
celda{9,5}=PER_DISresto;

%Lo pasa a excel.
nombre_hoja=['Generador',LETRA];
rango='A1';
xlswrite(['C:\Users\usuario\Desktop\pfc\pfc\',LETRA],celda,nombre_hoja,rango);

end



