function Generadores_variasSeries_distintosMuestras(series,Pnom)


%UTILIDAD:
    
    %Calcula la pot. nominal, la de trabajo, la suma de Pot. maximas y las perdidas por dispersion y totales de varios
           %seguidores con diferente n series y 4 modulos en serie.Y de algunos de sus modulos.
           %Dibuja las curvas de los modulos que forman los generadores simulados, sus PMP y los puntos de trebajo de algunos de ellos.

%VARIABLES DE ENTRADA:
    %modenserie: vector con los numeros de mdulos en serie que se desea simular.
    %Pnom: potencia nominal de los modulos utilizados.
    
    
warning off

%Lee los datos de los (36) modulos diferentes, creados medinte muestras aleatorias en nuestro caso. Para ello usamos la funcion curvaIVmodulos.

[V,I]= curvaIVnmodulos;

%Duplicamos el n de modulos disponibles cogiendo cad uno de ellos dos veces. En nuestro caso tendramos 72.
mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

%Duplica el n de modulos de nuevo dos veces ms. Tendriamos 288 mdulos disponibles (36 repetidos 8 veces cada uno) 
mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
end

%Calcula la potencia en los puntos de la curva de cada mdulo.
for i=1:size(V,1)
    for t=1:size(V,2)
        P(i,t)=V(i,t)*I(i,t);
    end
end

%Dibuja las curvas de los modulos para una configuracion 9sx4p. y sus puntos de maxima potencia.
%figure
%for i=1:36
%    hold on
%    plot(V(i,:),I(i,:));
%    for t=1:size(P,2)
%        if P(i,t)==max(P(i,:))
%            lugar(i)=t;
%        end
%    end
%    plot(V(i,lugar(i)),I(i,lugar(i)),'k*');
%    xlabel('Tensin (V)');
%	ylabel('Corriente (A)');
%    title('9sx4p');
%end

%Calcula la potencia de trabajo, la nominal y la suma de potencias maximas para 
    %cada una de las configuraciones (cada una con 4 mdulos en cada serie y diferente n de series)

for i=1:length(series)
    
       [Vsinc{i} Isinc{i} Vser{i} Iser{i}]= calculoseguidor2(V(1:series(i)*4,:),I(1:series(i)*4,:),series(i),4,(1:series(i)*4));
       
       for p=1:length(Vsinc{i})
           
           Psinc{i}(1,p)=Vsinc{i}(1,p)*Isinc{i}(1,p);
           
           if Psinc{i}(1,p)==max(Psinc{i}(1,:))
               lugarGEN(i)=p;
           end
       end

       PsincMAX(i)=max(Psinc{i});
       Pideal(i)=Pnom*series(i)*4;
       
end

%Calcula la suma de potencias maximas de los modulos de cada generador.
for i=1:length(series)
    Psuma_de_maximas(i)=0;
    for p=1:4*series(i)
        Psuma_de_maximas(i)=Psuma_de_maximas(i)+ max(P(p,:));
    end
end
 


%Calcula la potencia de trabajo de los 5 modulos (1 5 10 13 16)de cada configuracion con 4 series o con 4 modulos en serie.
    %calcula la corriente de cada serie.
modulos=[1 4 12 14];
for t=1:length(series)
    for i=1:length(modulos)
       ser=fix(modulos(i)/4);
       if fix(modulos(i)/4)==modulos(i)/4
       else
           ser=ser+1;
       end
            
            [Iseriereal{i}(t)]=extrapola2ju(Vser{t}(ser,:),Iser{t}(ser,:),Vsinc{t}(1,lugarGEN(t)));
            [Vmodmoden{i}(t)]=extrapola2ju(I(modulos(i),:),V(modulos(i),:),Iseriereal{i}(t));
            Pmodmoden{i}(t)=Vmodmoden{i}(t)*Iseriereal{i}(t);
    end
end

%Dibuja los puntos de trabajo de 5 modulos por separado y para cada n de modulos en serie. 
%for t=1:length(modenserie)
%    figure
%    hold on
%   for i=1:length(modulos)
%        plot(V(modulos(i),:),I(modulos(i),:));
%        plot(V(modulos(i),lugar(modulos(i))),I(modulos(i),lugar(modulos(i))),'k*');
%        plot(Vmodmoden{modulos(i)}(t),Iseriereal{modulos(i)}(t),'ro');
%    end
%    xlabel('Tensin (V)');
%	ylabel('Corriente (A)');
%     title([num2str(modenserie(t)),'sx4p 1 5 10 13 16']);
%end

%PRUEBA: dibuja los 8 primeros modulos, distinguiendo el 1 y el 8 para ver como son en cada n de modulos en serie.
%for t=1:length(series)
%    figure
%    hold on
%    for i=1:8
%        if i==1
 %           plot(V(i,:),I(i,:),'r');
%        elseif i==8
%          plot(V(i,:),I(i,:),'k');
%        else
%            plot(V(i,:),I(i,:));
%        end
%        if i==7
%        else
%            plot(V(i,lugar(i)),I(i,lugar(i)),'k*');
%            plot(Vmodmoden{i}(t),Iseriereal{i}(t),'ro');
%        end
%    end
%end




%Pone en una hoja excel las perdidas totales y las perdidas por dispersion para diferente n serieS y 4 modulos en serie.

celda{1,5}='PRDIDAS POR DISPERSIN';
celda{1,6}='PRDIDAS TOTALES';

celda{2,2}='?Pmax. sin defecto';
celda{2,3}='?Pmax. con defecto';
celda{2,4}='P.de trabajo';
celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';

celda{3,1}='GENERADORES';
for i=1:length(series)
    celda{3+i,1}=[num2str(series(i)),'modulos en serie.'];
end
celda{17,1}='Modulo 1';
for i=1:length(series)
    celda{17+i,1}=[num2str(series(i)),'series.'];
end 
celda{31,1}='Modulo 4';
for i=1:length(series)
    celda{31+i,1}=[num2str(series(i)),'series.'];
end 
celda{45,1}='Modulo 12';
for i=1:length(series)
    celda{45+i,1}=[num2str(series(i)),'series.'];
end  
celda{59,1}='Modulo 14';
for i=1:length(series)
    celda{59+i,1}=[num2str(series(i)),'series.'];
end  

%Pone los datos de cada generador.
for i=1:length(series)
    celda{3+i,2}=Pideal(i);
    celda{3+i,3}=Psuma_de_maximas(i);
    celda{3+i,4}= PsincMAX(i);
    celda{3+i,5}=(celda{3+i,3}-celda{3+i,4})/celda{3+i,2};
    celda{3+i,6}=(celda{3+i,2}-celda{3+i,4})/celda{3+i,2};
end

%Pone los datos de diferentes mdulos de cada generador. En cada uno el modulo ocupa diferente lugar y comparte generador con diferentes modulos.
v=[17 31 45 59];
for i=1:length(v)
    for t=1:length(series)
        comienzo=v(i);
        celda{comienzo+t,2}=Pnom;
        celda{comienzo+t,3}=max(P(modulos(i),:));
        celda{comienzo+t,4}=Pmodmoden{i}(t);
        celda{comienzo+t,5}=(celda{comienzo+t,3}-celda{comienzo+t,4})/celda{comienzo+t,2};
        celda{comienzo+t,6}=(celda{comienzo+t,2}-celda{comienzo+t,4})/celda{comienzo+t,2};
    end
end


nombre_hoja='serie MODULOS DISTINTOS';
rango='A1';
xlswrite(('C:\Users\usuario\Desktop\pfc\pfc\DISTINTOS_SER'),celda,nombre_hoja,rango);
end
