function Generadores_variosModenserie_def(segui,Dsegui,modenserie,LETRA)

%UTILIDAD:
    %Dibuja las curvas I-V y P-V del mod. defectuoso y del perfecto.As como de los puntos de trabajo del mod. def, de los de la misma serie y del resto,
    %cuando forman parte de varios seguidores de 4 series y de 2 4 6 8 12 o 32 modulos en serie.(todos iguales excepto uno defectuoso).
    %Ademas pone en una hoja excel la potencia nominl, la de trabajo de suma de potencias maximas y las prdidas por dispersin y totales de cada uno de
    %los modulos de cada generador y de ellos mismos.

%VARIABLES DE ENTRADA:
    %Dsegui: se crea mediante la funcin "crearD". Es una variable que tiene los datos del la hoja excel donde hay 4 hojas de datos de 4 modulos (tres iguales y uno con defecto).
    %LETRA: es el nombre,letra o nmero con el que se desee asignar al generador simulado.
    %segui: es el nombre de la subcarpeta que se encuentra dentro de la carpeta "para matlab", en la que estan los datos a utilizar. 
    %modenserie:vector con los n de modulos en serie de cada seguidor.(MAXIMO 7 VALORES,PARA QUE LO ESCRIBA BIEN EN EXCEL).


warning off

%Lee los datos del modulo def. y del perfecto.

nombredatos=Dsegui(1).name;
cont=1;
for i=1:2
nombre=['Modulo',num2str(cont)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:length(N),:);

V(:,i)=N(:,1);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I(:,i)=N(:,2);
cont=4;
end

Vtot=V';
Itot=I';

%Calcula la potencia para cad punto de la curva y la V y I en el PMP.
for i=1:2
    for t=1:size(Vtot,2)
        Ptot(i,t)=Vtot(i,t)*Itot(i,t);
        if Ptot(i,t)==max(Ptot(i,:))
            lugar(i)=t;
        end
    end
end

%Calcula la potencia nominal de los modulos (en este caso es la maxima del modulo perfecto y no la del fabricante)
Pnom=max(Ptot(1,:));

%Calcula la V y la I del seguidor para cada seguidor ( cad uno con un n de modulos en serie diferente).

for i=1:length(modenserie)
    for t=1:modenserie(i)*4
        if t==modenserie(i)*4
            Vmod{i}(t,:)=Vtot(2,:);
            Imod{i}(t,:)=Itot(2,:);
        else
            Vmod{i}(t,:)=Vtot(1,:);
            Imod{i}(t,:)=Itot(1,:);
        end
    end                     
[Vsegui{i} Isegui{i} Vser{i} Iser{i}]= calculoseguidor2(Vmod{i},Imod{i},4,modenserie(i),(1:modenserie(i)*4));
end

%Calcula la tension de trabajo de las series de cada seguidor.

for i=1:length(modenserie)
    for  t=1:size(Vsegui{i},2)
        Psegui{i}(1,t)=Vsegui{i}(1,t)*Isegui{i}(1,t);
        if Psegui{i}(1,t)==max(Psegui{i})
            VseguiREAL{i}=Vsegui{i}(1,t);
            lugarSEGUI{i}=t;
        end
    end
end

%Calcula la corriente que pasa por cada una de las serie de cada seguidor.

for i=1:length(modenserie)
    for t=1:4
        [IserieREAL{i}(t)]=extrapola2ju(Vser{i}(t,:),Iser{i}(t,:),VseguiREAL{i});
    end
end

%Calcula la tension de cada uno de los modulos de los generadores.

for i=1:length(modenserie)
   [VmodDEFreal{i}]=extrapola2ju(Itot(2,:),Vtot(2,:),IserieREAL{i}(4));
   [VmodMISMAreal{i}]=extrapola2ju(Itot(1,:),Vtot(1,:),IserieREAL{i}(4));
   [VmodRESTOreal{i}]=extrapola2ju(Itot(1,:),Vtot(1,:),IserieREAL{i}(1));
end

%Dibuja el mod. def y el perfecto y los puntos de trabajo de los modulos.
%cada configuracion de seguidor en una grafica diferente.

for i=1:length(modenserie)
    figure
    hold on
    plot(Vtot(1,:),Itot(1,:),'b');
    plot(Vtot(2,:),Itot(2,:),'r');
    plot(Vtot(1,lugar(1)),Itot(1,lugar(1)),'b*');
    plot(Vtot(2,lugar(2)),Itot(2,lugar(2)),'b*');

    plot(VmodDEFreal{i},IserieREAL{i}(4),'ro');
    plot(VmodMISMAreal{i},IserieREAL{i}(4),'ko');
    plot(VmodRESTOreal{i},IserieREAL{i}(1),'bo');

    %Dibuja la curva P-V de cada seguidor.
    
        %Pone la tension y la potencia del seguidor a la escala que mas convenga. Solo es adecuado si se utiliza modenserie=(2 4 6 8 12 16 32).
            if i==1
                valor=2;
                valor2=200;
                
            elseif i==2
                valor=4;
                valor2=450;
                
            elseif i==3
                valor=6;
                valor2=600;
                
            elseif i==4
                valor=8;
                valor2=850;
        
            elseif i==5
                valor=12;
                valor2=1300;
                
            elseif i==6
                valor=15;
                valor2=1700;
                
            elseif i==7
                valor=30;
                valor2=3600;
            end
        
    for t=1:length(Vsegui{i})         
        VseguiESCALA{i}(t)=Vsegui{i}(t)/valor;
        PseguiESCALA{i}(t)=Psegui{i}(t)/valor2;
    end
           
            
    plot(VseguiESCALA{i},PseguiESCALA{i},'k--');
    plot(VseguiESCALA{i}(1,lugarSEGUI{i}),PseguiESCALA{i}(1,lugarSEGUI{i}),'k*');
    
    xlabel(['Tensin (V),Tensin (V/',num2str(valor),')']);
	ylabel(['Corriente (A), Potencia (W/',num2str(valor2),')']);
    NUMER=num2str(modenserie(i));
    title([NUMER,'sx4p']);
end
%Calcula las perdidas totales y por dispersion de cada seguidor.

for i=1:length(modenserie)
    POTideal{i}=4*modenserie(i)*max(Ptot(1,:));
    PerdTOTsegui{i}=(POTideal{i}-max(Psegui{i}))/POTideal{i};
    PmaxDEF=max(Ptot(2,:));
    PmaxPER=max(Ptot(1,:));
    PerdDISPsegui{i}=((PmaxPER*(modenserie(i)*4-1)+PmaxDEF)-max(Psegui{i}))/POTideal{i};
end

%Calcula las perdidas totales y por dispersion de cada tipo de modulo de cada seguidor.

for i=1:length(modenserie)
    PmodDEFreal{i}=VmodDEFreal{i}*IserieREAL{i}(4);
    PmodMISMAreal{i}=VmodMISMAreal{i}*IserieREAL{i}(4);
    PmodRESTOreal{i}=VmodRESTOreal{i}*IserieREAL{i}(1);
    
    PerdTOT_def{i}=(Pnom-PmodDEFreal{i})/Pnom;
    PerdTOT_misma{i}=(Pnom-PmodMISMAreal{i})/Pnom;
    PerdTOT_resto{i}=(Pnom-PmodRESTOreal{i})/Pnom;
    
    PerdDISP_def{i}=(PmaxDEF-PmodDEFreal{i})/Pnom;
    PerdDISP_misma{i}=(PmaxPER-PmodMISMAreal{i})/Pnom;
    PerdDISP_resto{i}=(PmaxPER-PmodRESTOreal{i})/Pnom;

end

%Pasa los datos a excel.

celda{1,5}='PRDIDAS POR DISPERSIN';
celda{1,6}='PRDIDAS TOTALES';

celda{2,2}='?Pmax. sin defecto';
celda{2,3}='?Pmax. con defecto';
celda{2,4}='P.de trabajo';
celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';

celda{3,1}=['Grupo de generadores',LETRA];
celda{12,1}='Mdulo defectuoso';
celda{21,1}='Mdulos misma serie';
celda{30,1}='Resto de mdulos';

for i=1:length(modenserie)
    celda{3+i,1}=[num2str(modenserie(i)),' mdulos en serie'];
    celda{3+i,2}=POTideal{i};
    celda{3+i,3}=(PmaxPER*(modenserie(i)*4-1)+PmaxDEF);
    celda{3+i,4}=max(Psegui{i});
    celda{3+i,5}=PerdDISPsegui{i};
    celda{3+i,6}=PerdTOTsegui{i};
    
    celda{12+i,1}=[num2str(modenserie(i)),' mdulos en serie'];
    celda{12+i,2}=PmaxPER;
    celda{12+i,3}=PmaxDEF;
    celda{12+i,4}=PmodDEFreal{i};
    celda{12+i,5}=PerdDISP_def{i};
    celda{12+i,6}=PerdTOT_def{i};
    
    celda{21+i,1}=[num2str(modenserie(i)),' mdulos en serie'];
    celda{21+i,2}=PmaxPER;
    celda{21+i,3}=PmaxPER;
    celda{21+i,4}=PmodMISMAreal{i};
    celda{21+i,5}=PerdDISP_misma{i};
    celda{21+i,6}=PerdTOT_misma{i};
    
    celda{30+i,1}=[num2str(modenserie(i)),' mdulos en serie'];
    celda{30+i,2}=PmaxPER;
    celda{30+i,3}=PmaxPER;
    celda{30+i,4}=PmodRESTOreal{i};
    celda{30+i,5}=PerdDISP_resto{i};
    celda{30+i,6}=PerdTOT_resto{i};
    
    
    
end
   
    nombre_hoja=['Grupo de generadores',nombredatos];
    rango='A1';
    xlswrite(['C:\Users\usuario\Desktop\pfc\pfc\',LETRA,],celda,nombre_hoja,rango);

end



