function Paralelo_2_modulos_def(Dsegui,segui,serie,modenserie,nom)

%UTILIDAD:
 % Calcula las prdidas por dispersin de generadores de varias configuraciones (con todods los modulos iguales excepto uno)
        %con la conexion "paralelo de 2 modulos" y tambien sin ella y las compara.
 % Dibuja graficas de prdidas en funcion del n de modulos en serie y series.
    
%VARIABLES DE ENTRADA:
    %Dsegui:se crea mediante la funcin "crearD". Es una variable que tiene los datos del la hoja excel donde hay 4 hojas de datos de 4 modulos (tres iguales y uno con defecto).
    %segui: es el nombre de la subcarpeta que se encuentra dentro de la carpeta "para matlab", en la que estan los datos a utilizar.
    %serie: vector con los numeros de series que se desean simular.
    %modenserie:vector con los numeros de modulos en serie que se desean simular.
    %nom:nombre del grupo de generadores simulado (para que aparzca en el titulo de las graficas)



warning off 

%Crea las matrices  "X"(series) y "Y"(modenseries) del grafico 3D.

cont=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        x(cont)=modenserie(i);
        z(cont)=serie(k);
        cont=cont+1;
    end
end
contador=1;
for i=1:length(modenserie)
    for k=1:length(serie)
    X(i,k)=x(contador); %matriz de valores de modenserie. Cuando y=y{1,1} Y DifPot=DifPot{1,1} entonces el numero de modenserie es= a X{1,1}
    Y(i,k)=z(contador);
    contador=contador+1;
    end
end


%Lee los datos del mdulo defectuoso y del perfecto.

nombredatos=Dsegui(1).name;
cont=1;

for i=1:2
    
nombre=['Modulo',num2str(cont)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:length(N)-3,:);

V(:,i)=N(:,1);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I(:,i)=N(:,2);

cont=4;
end

Vtot=V';
Itot=I';

%Calcula la potencia en cada punto de la curva del modulo perfecto y del defectuoso.
for t=1:2
    for i=1:size(Vtot,2)
        Ptot(t,i)=Vtot(t,i)*Itot(t,i);
    end
end
    

%Calcula la curva I-V de la serie con el modulo defectuoso de cada generador y la curva de las series perfectas de cada generador 
    %(cada uno de ellos con una configuracion diferente).

for t=1:length(modenserie)
    
    %1 serie perfecta. Si "t" es cte. la serie perfecta es =sea cuansea el n de series.
        %As posteriomente se calcula la curva I-V de cada uno de los generadores sin aplicarles ninguna conexion intermedia.
    VserPer{t}=Vtot(1,:);
    IserPer{t}=Itot(1,:);
    
    for i=1:modenserie(t)-1
        [VserPer{t},IserPer{t}]=serie2stringsju(VserPer{t},IserPer{t},Vtot(1,:),Itot(1,:));
    end
    
    %1 serie con un mod def.Si te en cte. la serie def. es =sea cuansea el n se series.
    VserDef{t}=Vtot(1,:);
    IserDef{t}=Itot(1,:);
    
    for i=1:modenserie(t)-2
        [VserDef{t},IserDef{t}]=serie2stringsju(VserDef{t},IserDef{t},Vtot(1,:),Itot(1,:));
    end
    
    [VserDef{t},IserDef{t}]=serie2stringsju(VserDef{t},IserDef{t},Vtot(2,:),Itot(2,:));
    
    for k=1:length(serie)
        
        %curva I-V de los generadores sin ninguna conexion intermedia.
        Vf1{t,k}=VserPer{t};
        If1{t,k}=IserPer{t};
        
        for i=1:serie(k)-2
           [Vf1{t,k},If1{t,k}]=paralelo2stringsju(Vf1{t,k},If1{t,k},VserPer{t},IserPer{t});
        end
        
        [Vf1{t,k},If1{t,k}]=paralelo2stringsju(Vf1{t,k},If1{t,k},VserDef{t},IserDef{t});
        
        %calcula la potencia en cada punto de la curva.
        for i=1:length(Vf1{t,k})
            
            Pf1{t,k}(i)=Vf1{t,k}(i)*If1{t,k}(i);
            
            if max(Pf1{t,k})==Pf1{t,k}(i)
                lugarf1{t,k}=i;
            end
        end
        
        Maxf1(t,k)=max(Pf1{t,k});%Potencia maxima de cada generador.
    end
end

%Calcula la Pnom de los modulos. No utiliza la del fabricante, sino las maxima del modulo perfecto.
Pnom=max(Ptot(1,:));

%Calcula la curva I-V de cada una de las partes en que queda dividido el generador al aplicar la conexin "paralelo de 2 modulos".

%2series unidas por "paralelo de 2 modulos":parte que contiene el modulo defectuoso. Sea cual sea el n de series y modulos en serei es =.

[VparteDef,IparteDef]=paralelo2stringsju(Vtot(1,:),Itot(1,:),Vtot(2,:),Itot(2,:));

for t=1:length(modenserie)
    
    %2series unidas por "paralelo de 2 modulos":parte que no contiene el modulo defectuoso.Si "t" es cte, es= para cualquier n de series.
    VpartePer1{t}=Vtot(1,:);
    IpartePer1{t}=Itot(1,:);   
    
    for i=1:modenserie(t)-2
        [VpartePer1{t},IpartePer1{t}]=serie2stringsju(VpartePer1{t},IpartePer1{t},Vtot(1,:),Itot(1,:));
    end
    
    [VpartePer{t},IpartePer{t}]=paralelo2stringsju(VpartePer1{t},IpartePer1{t},VpartePer1{t},IpartePer1{t});
    
    %2series unidas por "paralelo de 2 modulos":uniendo las dos partes. Es = si "t" no vara.
    
    [V2s{t},I2s{t}]=serie2stringsju(VpartePer{t},IpartePer{t},VparteDef,IparteDef);
    
    for k=1:length(serie)
        
        %2series unidas por "paralelo de 2 modulos" en || con el resto de series perfectas.
        if serie(k)==2
            
            Vf{t,k}=V2s{t};
            If{t,k}=I2s{t};
            
        elseif serie(k)==3
            
            [Vf{t,k},If{t,k}]=paralelo2stringsju(V2s{t},I2s{t},VserPer{t},IserPer{t});
        else
            
            VsersPer{t,k}=VserPer{t};
            IsersPer{t,k}=IserPer{t};
            
            for i=1:serie(k)-3
                [VsersPer{t,k},IsersPer{t,k}]=paralelo2stringsju(VsersPer{t,k},IsersPer{t,k},VserPer{t},IserPer{t});
            end
            
            [Vf{t,k},If{t,k}]=paralelo2stringsju(V2s{t},I2s{t},VsersPer{t,k},IsersPer{t,k});
        end
        
        for i=1:length(Vf{t,k})
            Pf{t,k}(i)=Vf{t,k}(i)*If{t,k}(i);
            if max(Pf{t,k})==Pf{t,k}(i)
                lugarf{t,k}=i;
            end
        end 
        
        Maxf(t,k)=max(Pf{t,k});%Potencia maxima de cada generador.
        Pideal(t,k)=Pnom*modenserie(t)*serie(k);%potencia nominal de cada generador.
        PsumaMAX(t,k)=max(Ptot(1,:))*(modenserie(t)*serie(k)-1)+max(Ptot(2,:));%Suma de potencias maximas de cada uno de los modulos de cada generador.
        PerdidasTOTf(t,k)=(Pideal(t,k)-Maxf(t,k))/Pideal(t,k);%Prdidas totales en cada generador aplicando la conexion "paralelo de 2 modulos".
        PerdidasTOTf1(t,k)=(Pideal(t,k)-Maxf1(t,k))/Pideal(t,k);%Prdidas totales en cada generador sin aplicar ninguna conexion.
        DifPerdidasTOT(t,k)=PerdidasTOTf1(t,k)-PerdidasTOTf(t,k);% Diferencia de prdidas totales entre no aplicar ninguna conexion y aplicar la conexion "paralelo de 2 modulos"
        PerdidasDISPf(t,k)=(PsumaMAX(t,k)-Maxf(t,k))/Pideal(t,k);%Prdidas por dispersin en cada generador aplicando la conexion "paralelo de 2 modulos".
        PerdidasDISPf1(t,k)=(PsumaMAX(t,k)-Maxf1(t,k))/Pideal(t,k);%Prdidas por dispersin en cada generador sin aplicar ninguna conexion.
        DifPerdidasDISP(t,k)=PerdidasDISPf1(t,k)-PerdidasDISPf(t,k);%Prdidas por dispersin entre no aplicar ninguna conexion y aplicar la conexion "paralelo de 2 modulos"
    end
end

%Dibuja las prdidas totales y las de dispersin al apliar y al no apliar la conexion "paralelode 2 modulos" 
    %as como la diferencia entre dichas prdidas en fucion del n de modulos en serie del generador y el n de series.
    
figure
[C,h]=contourf(X,Y,DifPerdidasTOT);%dif perdidas totales
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc-PerdidasTOTunac(',nom,')']);%sinc -paralelo de 2 modulos"
figure
[C,h]=contourf(X,Y,PerdidasTOTf);%"paralelode 2 modulos" 
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTunac(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTf1);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc(',nom,')']);

figure
[C,h]=contourf(X,Y,DifPerdidasDISP);%dif perdidas dispersion
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc-PerdidasDISPunac(',nom,')']);%sinc -"paralelode 2 modulos" 
figure
[C,h]=contourf(X,Y,PerdidasDISPf);%unac
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPunac(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPf1);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc(',nom,')']);




%modenserie2=modenserie(1:10);
%serie2=serie(1:10);

%Dibuja las curvas I-V de los modulos de varias series y 4 moden serie y de 4 series y varios modenserie y dibuja tb los puntos de trabajo de:
    %modulo defectuoso
    %los modulos de las series que se unen
        %el que esta en paralelo con el def.
        %y el resto
    %el resto.
%Y tambien pasa los resultados a excel.
    
%Los generadores son de todos los mdulos iguales menos uno.
%Dsegui tiene los datos de un generadore 9sx4p 4sx9p.
%series(2)=4 y modenserie(2)=4 obligatoriamente.



%Para 4 series y varios modenserie.


%for i=1:length(modenserie2)
    
    %Calcula la corriente de las series que no se unen (serie 3 y serie 4).
    
%    VserPerREAL(i)=Vf{modenserie2(i)-1,3}(1,lugarf{modenserie2(i)-1,3});%{modenserie2(i)-1,3}porque 3 es la posicion que 4series ocupa en el vector series.
%    [IserPerREAL(i)]=extrapola2ju(VserPer{modenserie2(i)-1},IserPer{modenserie2(i)-1},VserPerREAL(i));
%    
%    %Calcula la tension de cada modulo de las series no unidas.
%    
%    [VModserPerREAL(i)]=extrapola2ju(Itot(1,:),Vtot(1,:),IserPerREAL(i));
%    PModserPerREAL(i)=VModserPerREAL(i)*IserPerREAL(i);
%     
%    %Calcula la corriente que pasa por las series unidas.
%    
%    [I2sREAL(i)]=extrapola2ju(V2s{modenserie2(i)-1},I2s{modenserie2(i)-1},Vf{modenserie2(i)-1,3}(1,lugarf{modenserie2(i)-1,3}));%{modenserie2(i)-1,3}porque3 es la posicion que 4series ocupa en el vector series.
%    
%    %Calcula la tension de la parte perfecta.
%    
%    [VpartePerREAL(i)]=extrapola2ju(IpartePer{modenserie2(i)-1},VpartePer{modenserie2(i)-1},I2sREAL(i));
%    
%    %Clcula la corriente de cad serie de la parte perfecta unida.
%    
%    [IpartePer1sREAL(i)]=extrapola2ju(VpartePer1{modenserie2(i)-1},IpartePer1{modenserie2(i)-1},VpartePerREAL(i));
%    
%    %Calcula la tension de cada modulo de la parte perfecta unida.
%    
%    [VModPartePerREAL(i)]=extrapola2ju(Itot(1,:),Vtot(1,:),IpartePer1sREAL(i));
%    PModPartePerREAL(i)=VModPartePerREAL(i)*IpartePer1sREAL(i);
%    
%    %Calcula corriente del modulo def.
%    
%    VModDefREAL(i)=Vf{modenserie2(i)-1,3}(1,lugarf{modenserie2(i)-1,3})-VpartePerREAL(i);
%    [IModDefREAL(i)]=extrapola2ju(Vtot(2,:),Itot(2,:), VModDefREAL(i));
%    PModDefREAL(i)=VModDefREAL(i)*IModDefREAL(i);
%    
 %   %Calcula la tension del modulo en || con def.
 %   
 %   IModParaleloREAL(i)=I2sREAL(i)-IModDefREAL(i);
  %  [VModParaleloREAL(i)]=extrapola2ju(Itot(1,:),Vtot(1,:),IModParaleloREAL(i));
  %  PModParaleloREAL(i)=VModParaleloREAL(i)*IModParaleloREAL(i);
%end
 
%Dibuja las curvas IV y los puntos de trabajo.



%for i=1:length(modenserie2)
%    figure
%    hold on
%    plot(Vtot(1,:),Itot(1,:));
%    plot(Vtot(2,:),Itot(2,:),'r');
%    plot(Vtot(1,lugar(1)),Itot(1,lugar(1)),'b*');
%    plot(Vtot(2,lugar(2)),Itot(2,lugar(2)),'b*');
%    
%   plot(VModDefREAL(i),IModDefREAL(i),'ro');
%    plot(VModParaleloREAL(i),IModParaleloREAL(i),'go');
%    plot(VModPartePerREAL(i),IpartePer1sREAL(i),'ko');
%    plot(VModserPerREAL(i),IserPerREAL(i),'bo');
 %   Xlabel('Tension (V)');
 %   ylabel('Corriente (A)');
 %   title(['UNA CONEXION (',num2str(modenserie2(i)),'sx4p)']);
%end

%Crea celda para guardar en excel.

%celda{1,1}='UNA CONEXION';
%celda{1,5}='PRDIDAS POR DISPERSIN';
%celda{1,6}='PRDIDAS TOTALES';

%celda{2,2}='?Pmax. sin defecto';
%celda{2,3}='?Pmax. con defecto';
%celda{2,4}='P.de trabajo';
%celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
%celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';

%celda{3,1}='GENERADORES';
%for i=1:length(modenserie2)
%    celda{3+i,1}=[num2str(modenserie2(i)),'modulos en serie.'];
%end
%celda{17,1}='Modulo Def';
%for i=1:length(modenserie2)
%    celda{17+i,1}=[num2str(modenserie2(i)),'modulos en serie.'];
%end 
%celda{31,1}='Modulo || def.';
%for i=1:length(modenserie2)
%    celda{31+i,1}=[num2str(modenserie2(i)),'modulos en serie.'];
%end 
%celda{45,1}='Modulos parte perfecta unida';
%for i=1:length(modenserie2)
%    celda{45+i,1}=[num2str(modenserie2(i)),'modulos en serie.'];
%end 
%celda{59,1}='Modulos resto ';
%for i=1:length(modenserie2)
%    celda{59+i,1}=[num2str(modenserie2(i)),'modulos en serie.'];
%end 


%for i=1:length(modenserie2)
%    
%    Maxf;
%    Pideal;
%    PsumaMAX;

 %   celda{3+i,2}=Pnom*4*modenserie2(i);
 %   celda{3+i,3}=max(Ptot(2,:))+max(Ptot(1,:))*(4*modenserie2(i)-1);
 %   celda{3+i,4}= Maxf(modenserie2(i)-1,3);%(i,3)porque 3 es la posicion que 4series ocupa en el vector series.
 %   celda{3+i,5}=(celda{3+i,3}-celda{3+i,4})/celda{3+i,2};
 %   celda{3+i,6}=(celda{3+i,2}-celda{3+i,4})/celda{3+i,2};
 %   
 %   celda{17+i,2}=Pnom;
 %   celda{17+i,3}=max(Ptot(2,:));
 %   celda{17+i,4}= PModDefREAL(i);
 %   celda{17+i,5}=(celda{17+i,3}-celda{17+i,4})/celda{17+i,2};
 %   celda{17+i,6}=(celda{17+i,2}-celda{17+i,4})/celda{17+i,2};
 %   
 %   celda{31+i,2}=Pnom;
 %   celda{31+i,3}=max(Ptot(1,:));
 %   celda{31+i,4}= PModParaleloREAL(i);
 %   celda{31+i,5}=(celda{31+i,3}-celda{31+i,4})/celda{31+i,2};
 %   celda{31+i,6}=(celda{31+i,2}-celda{31+i,4})/celda{31+i,2};
    
  %  celda{45+i,2}=Pnom;
  %  celda{45+i,3}=max(Ptot(1,:));
  %  celda{45+i,4}= PModPartePerREAL(i);
  %  celda{45+i,5}=(celda{45+i,3}-celda{45+i,4})/celda{45+i,2};
  %  celda{45+i,6}=(celda{45+i,2}-celda{45+i,4})/celda{45+i,2};
  %  
  %  celda{59+i,2}=Pnom;
  %  celda{59+i,3}=max(Ptot(1,:));
  %  celda{59+i,4}= PModserPerREAL(i);
  %  celda{59+i,5}=(celda{59+i,3}-celda{59+i,4})/celda{59+i,2};
  %  celda{59+i,6}=(celda{59+i,2}-celda{59+i,4})/celda{59+i,2};
%end

%nombre_hoja='modenserie 1malo';
%rango='A1';
%xlswrite((['C:\Users\usuario\Desktop\pfc\pfc\UNAC_1malo',nom]),celda,nombre_hoja,rango);


%Varias series(4 modenserie)

%for i=1:length(serie2)
    
    %Calcula la corriente de las series que no se unen (todas menos serie 1 y serie 2).
    
 %   VserPerREAL(i)=Vf{3,serie2(i)-1}(1,lugarf{3,serie2(i)-1});%{3,serie2(i)-1}porque 3 es la posicion que 4 modenserie ocupa en el vector modenserie.
 %   [IserPerREAL(i)]=extrapola2ju(VserPer{3},IserPer{3},VserPerREAL(i));
    
    %Calcula la tension de cada modulo de las series no unidas.
    
 %   [VModserPerREAL(i)]=extrapola2ju(Itot(1,:),Vtot(1,:),IserPerREAL(i));
 %   PModserPerREAL(i)=VModserPerREAL(i)*IserPerREAL(i);
     
    %Calcula la corriente que pasa por las series unidas.
    
  %  [I2sREAL(i)]=extrapola2ju(V2s{3},I2s{3},Vf{3,serie2(i)-1}(1,lugarf{3,serie2(i)-1}));%{3,i}porque 3 es la posicion que 4 modenserie ocupa en el vector modenserie.
   % 
    %Calcula la tension de la parte perfecta.
    
   % [VpartePerREAL(i)]=extrapola2ju(IpartePer{3},VpartePer{3},I2sREAL(i));
    
    %Clcula la corriente de cad serie de la parte perfecta unida.
    
   % [IpartePer1sREAL(i)]=extrapola2ju(VpartePer1{3},IpartePer1{3},VpartePerREAL(i));
    
    %Calcula la tension de cada modulo de la parte perfecta unida.
    
   % [VModPartePerREAL(i)]=extrapola2ju(Itot(1,:),Vtot(1,:),IpartePer1sREAL(i));
   % PModPartePerREAL(i)=VModPartePerREAL(i)*IpartePer1sREAL(i);
    
    %Calcula corriente del modulo def.
    
   % VModDefREAL(i)=Vf{3,serie2(i)-1}(1,lugarf{3,serie2(i)-1})-VpartePerREAL(i);
   % [IModDefREAL(i)]=extrapola2ju(Vtot(2,:),Itot(2,:), VModDefREAL(i));
   % PModDefREAL(i)=VModDefREAL(i)*IModDefREAL(i);
    
    %Calcula la tension del modulo en || con def.
    
   % IModParaleloREAL(i)=I2sREAL(i)-IModDefREAL(i);
   % [VModParaleloREAL(i)]=extrapola2ju(Itot(1,:),Vtot(1,:),IModParaleloREAL(i));
   % PModParaleloREAL(i)=VModParaleloREAL(i)*IModParaleloREAL(i);
%end

%for i=1:length(serie2)
%    figure
%    hold on
%    plot(Vtot(1,:),Itot(1,:));
%    plot(Vtot(2,:),Itot(2,:),'r');
 %   plot(Vtot(1,lugar(1)),Itot(1,lugar(1)),'b*');
  %  plot(Vtot(2,lugar(2)),Itot(2,lugar(2)),'b*');
    
 %   plot(VModDefREAL(i),IModDefREAL(i),'ro');
 %   plot(VModParaleloREAL(i),IModParaleloREAL(i),'go');
 %   plot(VModPartePerREAL(i),IpartePer1sREAL(i),'ko');
 %   plot(VModserPerREAL(i),IserPerREAL(i),'bo');
 %   Xlabel('Tension (V)');
 %   ylabel('Corriente (A)');
 %   title(['UNA CONEXION (4sx',num2str(serie2(i)),'p)']);
%end


%Crea celda para guardar en excel.

%celda{1,1}='UNA CONEXION';
%celda{1,5}='PRDIDAS POR DISPERSIN';
%celda{1,6}='PRDIDAS TOTALES';%

%celda{2,2}='?Pmax. sin defecto';
%celda{2,3}='?Pmax. con defecto';
%celda{2,4}='P.de trabajo';
%celda{2,5}='(?Pmax. con defecto-P.de trabajo)/Pnom del gen.';
%celda{2,6}='(?Pmax. sin defecto-P.de trabajo)/Pnom del gen.';%

%celda{3,1}='GENERADORES';
%for i=1:length(serie2)
%    celda{3+i,1}=[num2str(serie2(i)),'series.'];
%end
%celda{17,1}='Modulo Def';
%for i=1:length(serie2)
%    celda{17+i,1}=[num2str(serie2(i)),'series.'];
%end 
%celda{31,1}='Modulo || def.';
%for i=1:length(serie2)
%    celda{31+i,1}=[num2str(serie2(i)),'series.'];
%end 
%celda{45,1}='Modulos parte perfecta unida';
%for i=1:length(serie2)
%    celda{45+i,1}=[num2str(serie2(i)),'series.'];
%end 
%celda{59,1}='Modulos resto ';
%for i=1:length(serie2)
%    celda{59+i,1}=[num2str(serie2(i)),'series.'];
%end 


%for i=1:length(serie2)

 %   celda{3+i,2}=Pnom*4*serie2(i);
 %   celda{3+i,3}=max(Ptot(2,:))+max(Ptot(1,:))*(4*serie2(i)-1);
 %   celda{3+i,4}= Maxf(3,serie2(i)-1);%(i,2)porque 2 es la posicion que 4series ocupa en el vector series.
 %   celda{3+i,5}=(celda{3+i,3}-celda{3+i,4})/celda{3+i,2};
 %   celda{3+i,6}=(celda{3+i,2}-celda{3+i,4})/celda{3+i,2};
 %   
 %   celda{17+i,2}=Pnom;
 %   celda{17+i,3}=max(Ptot(2,:));
 %   celda{17+i,4}= PModDefREAL(i);
 %   celda{17+i,5}=(celda{17+i,3}-celda{17+i,4})/celda{17+i,2};
 %   celda{17+i,6}=(celda{17+i,2}-celda{17+i,4})/celda{17+i,2};
 %   
 %   celda{31+i,2}=Pnom;
 %   celda{31+i,3}=max(Ptot(1,:));
 %   celda{31+i,4}= PModParaleloREAL(i);
 %   celda{31+i,5}=(celda{31+i,3}-celda{31+i,4})/celda{31+i,2};
 %   celda{31+i,6}=(celda{31+i,2}-celda{31+i,4})/celda{31+i,2};
 %   
 %   celda{45+i,2}=Pnom;
 %   celda{45+i,3}=max(Ptot(1,:));
 %   celda{45+i,4}= PModPartePerREAL(i);
 %   celda{45+i,5}=(celda{45+i,3}-celda{45+i,4})/celda{45+i,2};
 %   celda{45+i,6}=(celda{45+i,2}-celda{45+i,4})/celda{45+i,2};
 %   
 %   celda{59+i,2}=Pnom;
 %   celda{59+i,3}=max(Ptot(1,:));
 %   celda{59+i,4}= PModserPerREAL(i);
 %   celda{59+i,5}=(celda{59+i,3}-celda{59+i,4})/celda{59+i,2};
 %   celda{59+i,6}=(celda{59+i,2}-celda{59+i,4})/celda{59+i,2};
%end

%nombre_hoja='series 1malo';
%rango='A1';
%xlswrite((['C:\Users\usuario\Desktop\pfc\pfc\UNAC_1malo',nom]),celda,nombre_hoja,rango);

end
