function Paralelo_2_modulos_distintosReales(D,segui,serie,modenserie,Pnom,nom)

%UTILIDAD:
    % Calcula las prdidas por dispersin de generadores de varias configuraciones (con todods los modulos distintos, creados mediante muestras reales)
        %con la conexion "paralelo de 2 modulos" y tambien sin ella y las compara. 
    % Dibuja graficas de prdidas en funcion del n de modulos en serie y series.
    
%VARIABLES DE ENTRADA:
    %D:se crea mediante la funcin "crearD". Es una variable que tiene los datos del la hoja excel donde hay 36 hojas de datos, cada una de un
        %modulo medido y pasado a STC.
    %segui: es el nombre de la subcarpeta que se encuentra dentro de la carpeta "para matlab", en la que estan los datos a utilizar.
    %serie: vector con los numeros de series que se desean simular.
    %modenserie:vector con los numeros de modulos en serie que se desean simular.
    %nom:nombre del grupo de generadores simulado (para que aparzca en el titulo de las graficas)
    %Pnom: potencia nominal de los modulos.

warning off 

%Crea las matrices para "X"(series) y "Y"(modenseries) del grafico 3D.

cont=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        x(cont)=modenserie(i);
        z(cont)=serie(k);
        cont=cont+1;
    end
end
contador=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        X(k,i)=x(contador); %matriz de valores de modenserie. Cuando y=y{1,1} Y DifPot=DifPot{1,1} entonces el numero de modenserie es= a X{1,1}
        Y(k,i)=z(contador);
        contador=contador+1;
    end
end
    
%Lee los datos de todos los 36 modulos diferentes.

nombredatos=D.name;

for i=1:36
    
nombre=['Modulo',num2str(i)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:length(N)-3,:);
    
V(:,i)=N(:,15);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I(:,i)=N(:,16);

end

V=V';
I=I';

%Calcula la V y la I encada punto de la curva de cada modulo.

for i=1:size(V,1)
    for t=1:size(V,2)
        P(i,t)=V(i,t)*I(i,t);
    end
end

%Duplica los modulos que se tienen repiendo dos veces cada uno de los 36, as se tienen 72 modulos.

mod=size(V,1);
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
    P(mod+i,:)=P(i,:);
end


%Calcula la V, I y P de cada generadore (cada uno con diferente configuracin)sin aplicarles ninguna conexion intermedia.

for i=1:length(modenserie)
    
   for t=1:length(serie)
       
       [Vsinc{t,i} Isinc{t,i}]= calculoseguidor2(V(1:modenserie(i)*serie(t),:),I(1:modenserie(i)*serie(t),:),serie(t),modenserie(i),(1:modenserie(i)*serie(t)));
       
       for p=1:length(Vsinc{t,i})
           Psinc{t,i}(1,p)=Vsinc{t,i}(1,p)*Isinc{t,i}(1,p);
       end

       PsincMAX(t,i)=max(Psinc{t,i});
   end
end


%Calcula la V, I y P de cada generadore (cada uno con diferente configuracin) al aplicarles la conexin "Paralelo de 2 modulos".
    %Lo hace por partes.
    
%Calcula la V y la I de la series que no se conectan(todas menos 2). Y las pone en paralelo.

empieza=1;

 for i=1:length(serie)
     
     for t=1:length(modenserie)
         
       if serie(i)==2
       else
           
         for q=1:serie(i)-2
             
            Vser{i,t}(q,:)=V(empieza,:);
            Iser{i,t}(q,:)=I(empieza,:);
            
            for p=1:modenserie(t)-1
                [Vser{i,t}(q,:) Iser{i,t}(q,:)]=serie2stringsju(Vser{i,t}(q,:),Iser{i,t}(q,:),V(empieza+p,:),I(empieza+p,:));
            end
            
            empieza=empieza+modenserie(t);
            
            if q==serie(i)-2
                empieza=1;
            end
            
            %Paralelo de las series.
            
            if q==1
                
                Vpar{i,t}=Vser{i,t}(q,:);
                Ipar{i,t}=Iser{i,t}(q,:);
                
            else
                
                [Vpar{i,t} Ipar{i,t}]=paralelo2stringsju(Vpar{i,t},Ipar{i,t},Vser{i,t}(q,:),Iser{i,t}(q,:));
            
            end
         end
       end
     end
 end

 %Calcula las 2 serie restantes (menos un modulo cada una) y las pone en paralelo.

 for i=1:length(serie)
     
    for t=1:length(modenserie)
        
        for q=1:2
            
            if q==1
                
                empieza=modenserie(t)*serie(i)-(modenserie(t)*2-1);
            else
                
                empieza=modenserie(t)*serie(i)-(modenserie(t)-1);
            end
            
            VserCORTA{i,t}(q,:)=V(empieza,:);
            IserCORTA{i,t}(q,:)=I(empieza,:);
            
            for p=1:modenserie(t)-2
                
                [VserCORTA{i,t}(q,:) IserCORTA{i,t}(q,:)]=serie2stringsju(VserCORTA{i,t}(q,:),IserCORTA{i,t}(q,:),V(empieza+p,:),I(empieza+p,:));
            end
            
            %paralelo de las series(menos 1 modulo).
            
            if q==2
                
                [VparCORTA{i,t} IparCORTA{i,t}]=paralelo2stringsju(VserCORTA{i,t}(1,:),IserCORTA{i,t}(1,:),VserCORTA{i,t}(q,:),IserCORTA{i,t}(q,:));
            end
        end
    end
end

%Calcula el paralelo de los 2 modulos unidos.

for i=1:length(serie)
    
    for t=1:length(modenserie)
        
        [VparUNIDOS{i,t} IparUNIDOS{i,t}]=paralelo2stringsju(V(modenserie(t)*serie(i),:),I(modenserie(t)*serie(i),:),V(modenserie(t)*serie(i)-modenserie(t),:),I(modenserie(t)*serie(i)-modenserie(t),:));
    end
end

%Une en serie las dos partes de las 2 series unidas.
for i=1:length(serie)
    
    for t=1:length(modenserie)
        
        [V2series{i,t} I2series{i,t}]=serie2stringsju(VparCORTA{i,t},IparCORTA{i,t},VparUNIDOS{i,t},IparUNIDOS{i,t});
    end
end

%Une todo.

for i=1:length(serie)
    
    for t=1:length(modenserie)
        
        if serie(i)==2
            
            VGEN{i,t}=V2series{i,t};
            IGEN{i,t}=I2series{i,t};
            
        else
            [VGEN{i,t} IGEN{i,t}]=paralelo2stringsju(V2series{i,t},I2series{i,t},Vpar{i,t},Ipar{i,t});
        end
        
        for q=1:length(VGEN{i,t})
            
            PGEN{i,t}(1,q)=VGEN{i,t}(1,q)*IGEN{i,t}(1,q);
        end
        
        PMAX(i,t)=max(PGEN{i,t});%Potencia de trabajo de cada generador.
        Pideal(i,t)=Pnom*modenserie(t)*serie(i);%Potencia nominal de cada generador.
        PerdidasTOTsinc(i,t)=(Pideal(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas totales de cada generadore sin aplicar nin guna conexion intermedia.
        PerdidasTOTunac(i,t)=(Pideal(i,t)-PMAX(i,t))/Pideal(i,t);%Prdidas totales de cada generadore aplicando la conexion "Paralelo e 2 modulos"
        DifPerdidasTOT(i,t)=PerdidasTOTsinc(i,t)-PerdidasTOTunac(i,t);%diferencia de prdidas entre aplicar y no aplicar la conexion "Paralelo de 2 modulos"
    end
end

%Calculo de las prdidas por dispersin en cada generador.
for t=1:length(modenserie)
        empezar=1;
        for i=1:length(serie)
            if i==1 
                PsumaMAX(i,t)=0;
            else
                PsumaMAX(i,t)=PsumaMAX(i-1,t);
            end
            modulos=modenserie(t)*serie(i);
            for p=empezar:modulos
                PsumaMAX(i,t)=PsumaMAX(i,t)+max(P(p,:));
            end
            empezar=modulos+1;
            
            PerdidasDISPsinc(i,t)=(PsumaMAX(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas por dispersion de cada generadore sin aplicar nin guna conexion intermedia.
            PerdidasDISPtodo(i,t)=(PsumaMAX(i,t)-PMAX(i,t))/Pideal(i,t);%Prdidas por dispersion de cada generadore aplicando la conexion "Paralelo e 2 modulos"
            DifPerdidasDISP(i,t)=PerdidasDISPsinc(i,t)-PerdidasDISPtodo(i,t);%diferencia de prdidas entre aplicar y no aplicar la conexion "Paralelo de 2 modulos"
        end
    end


figure
[C,h]=contourf(X,Y,DifPerdidasTOT);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc-PerdidasTOTunaconexion(',nom,')']);%sinc-"Paralelo e 2 modulos"
figure
[C,h]=contourf(X,Y,PerdidasTOTunac);%"Paralelo e 2 modulos" 
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTunaconexion(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc(',nom,')']);

%DISPERSION
figure
[C,h]=contourf(X,Y,DifPerdidasDISP);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc-PerdidasDIPSunac(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPtodo);%"Paralelo e 2 modulos"
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPunac(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc(',nom,')']);
end