function  Paralelo_N_modulos_def(Dsegui,segui,serie,modenserie,nom)

%UTILIDAD:
 % Calcula las prdidas por dispersin de generadores de varias configuraciones (con todods los modulos iguales excepto uno)
        %con la conexion "paralelo de N modulos" y tambien sin ella y las compara.
 % Dibuja graficas de prdidas en funcion del n de modulos en serie y series.
    
%VARIABLES DE ENTRADA:
    %Dsegui:se crea mediante la funcin "crearD". Es una variable que tiene los datos del la hoja excel donde hay 4 hojas de datos de 4 modulos (tres iguales y uno con defecto).
    %segui: es el nombre de la subcarpeta que se encuentra dentro de la carpeta "para matlab", en la que estan los datos a utilizar.
    %serie: vector con los numeros de series que se desean simular.
    %modenserie:vector con los numeros de modulos en serie que se desean simular.
    %nom:nombre del grupo de generadores simulado (para que aparzca en el titulo de las graficas)

warning off 

%Crea las matrices para "X"(series) y "Y"(modenseries) del grafico 3D.

cont=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        x(cont)=modenserie(i);
        z(cont)=serie(k);
        cont=cont+1;
    end
end
contador=1;
for i=1:length(modenserie)
    for k=1:length(serie)
    X(i,k)=x(contador); %matriz de valores de modenserie. Cuando y=y{1,1} Y DifPot=DifPot{1,1} entonces el numero de modenserie es= a X{1,1}
    Y(i,k)=z(contador);
    contador=contador+1;
    end
end


%Lee los datos del modulo def. y del perfecto.
nombredatos=Dsegui(1).name;
cont=1

for i=1:2
    
nombre=['Modulo',num2str(cont)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:length(N)-3,:);

V(:,i)=N(:,1);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
I(:,i)=N(:,2);

cont=4;
end

Vtot=V';
Itot=I';

%Calcula la potencia en cada punto de la curva del modulo perfecto y del defectuoso.
for i=1:size(Vtot,1)
    for t=1:size(Vtot,2)
        Ptot(i,t)=Vtot(i,t)*Itot(i,t);
    end
end


%Calcula la curva I-V de la serie con el modulo defectuoso de cada generador y la curva de las series perfectas de cada generador 
    %(cada uno de ellos con una configuracion diferente).

for t=1:length(modenserie)
    
    %1 serie perfecta. Si "t" es cte. la serie perfecta es =sea cuansea el n de series.
        %As posteriomente se calcula la curva I-V de cada uno de los generadores sin aplicarles ninguna conexion intermedia.

    VserPer{t}=Vtot(1,:);
    IserPer{t}=Itot(1,:);
    
    for i=1:modenserie(t)-1
        [VserPer{t},IserPer{t}]=serie2stringsju(VserPer{t},IserPer{t},Vtot(1,:),Itot(1,:));
    end
    
    %1 serie con un mod def.Si te en cte. la serie def. es =sea cuansea el n se series.
    VserDef{t}=Vtot(1,:);
    IserDef{t}=Itot(1,:);
    
    for i=1:modenserie(t)-2
        [VserDef{t},IserDef{t}]=serie2stringsju(VserDef{t},IserDef{t},Vtot(1,:),Itot(1,:));
    end
    
    [VserDef{t},IserDef{t}]=serie2stringsju(VserDef{t},IserDef{t},Vtot(2,:),Itot(2,:));
    
    for k=1:length(serie)
        
        %curva I-V de los generadores sin ninguna conexion intermedia.
        Vf1{t,k}=VserPer{t};
        If1{t,k}=IserPer{t};
        
        for i=1:serie(k)-2
           [Vf1{t,k},If1{t,k}]=paralelo2stringsju(Vf1{t,k},If1{t,k},VserPer{t},IserPer{t});
        end
        
        [Vf1{t,k},If1{t,k}]=paralelo2stringsju(Vf1{t,k},If1{t,k},VserDef{t},IserDef{t});

        %calcula la potencia en cada punto de la curva.
        for i=1:length(Vf1{t,k})
            
            Pf1{t,k}(i)=Vf1{t,k}(i)*If1{t,k}(i);
            
            if max(Pf1{t,k})==Pf1{t,k}(i)
                lugarf1{t,k}=i;
            end
        end
        
        Maxf1(t,k)=max(Pf1{t,k});
    end
end


%Calcula la Pnom de los modulos. No utiliza la del fabricante, sino las maxima del modulo perfecto.
Pnom=max(Ptot(1,:));


%Calcula la curva I-V de cada una de las partes en que queda dividido el generador al aplicar la conexin "paralelo de N modulos".

%todas las series unidas por "Paralelo de N modulos":parte con el modulo defectuoso. Sea cual sea serie el n de modulos en serie es =.

[VparteDef1,IparteDef1]=paralelo2stringsju(Vtot(1,:),Itot(1,:),Vtot(2,:),Itot(2,:));

for k=1:length(serie)
    
    if serie(k)==2
        
        VparteDef{k}=VparteDef1;
        IparteDef{k}=IparteDef1;
        
    elseif serie(k)==3
         [VparteDef{k},IparteDef{k}]=paralelo2stringsju(Vtot(1,:),Itot(1,:),VparteDef1,IparteDef1);
    else    
        
    VparteDef11{k}=Vtot(1,:);
    IparteDef11{k}=Itot(1,:);
    
    for i=1:serie(k)-3
         [VparteDef11{k},IparteDef11{k}]=paralelo2stringsju(Vtot(1,:),Itot(1,:),VparteDef11{k},IparteDef11{k});
    end
    
    [VparteDef{k},IparteDef{k}]=paralelo2stringsju(VparteDef11{k},IparteDef11{k},VparteDef1,IparteDef1);    
    end
end

%todas las series unidas por "Paralelo de N modulos":parte sin modulo defectuoso. Y union de las dos partes .

for t=1:length(modenserie)
    
    if modenserie(t)==2
        
        VpartePer1{t}=Vtot(1,:);
        IpartePer1{t}=Itot(1,:);
        
    elseif modenserie(t)==3
        [VpartePer1{t},IpartePer1{t}]=serie2stringsju(Vtot(1,:),Itot(1,:),Vtot(1,:),Itot(1,:));
    else
        
        VpartePer1{t}=Vtot(1,:);
        IpartePer1{t}=Itot(1,:);
        
        for i=1:modenserie(t)-2
        [VpartePer1{t},IpartePer1{t}]=serie2stringsju(VpartePer1{t},IpartePer1{t},Vtot(1,:),Itot(1,:));
        end
        
    end
    for k=1:length(serie)
        
        if serie(k)==2
            
            [VpartePer{t,k},IpartePer{t,k}]=paralelo2stringsju(VpartePer1{t},IpartePer1{t},VpartePer1{t},IpartePer1{t});
            
        elseif serie(k)==3
            
            [VpartePer11{t,k},IpartePer11{t,k}]=paralelo2stringsju(VpartePer1{t},IpartePer1{t},VpartePer1{t},IpartePer1{t});
            [VpartePer{t,k},IpartePer{t,k}]=paralelo2stringsju(VpartePer11{t,k},IpartePer11{t,k},VpartePer1{t},IpartePer1{t});
            
        else
            
            VpartePer{t,k}=VpartePer1{t};
            IpartePer{t,k}=IpartePer1{t};
            
            for i=1:serie(k)-1
                [VpartePer{t,k},IpartePer{t,k}]=paralelo2stringsju(VpartePer1{t},IpartePer1{t},VpartePer{t,k},IpartePer{t,k});
            end
            
        end
        
        [Vf{t,k},If{t,k}]=serie2stringsju(VpartePer{t,k},IpartePer{t,k},VparteDef{k},IparteDef{k});
        
        for i=1:length(Vf{t,k})
            
            Pf{t,k}(i)=Vf{t,k}(i)*If{t,k}(i);
            
            if max(Pf{t,k})==Pf{t,k}(i)
                lugarf{t,k}=i;
            end     
            
        end
        Maxf(t,k)=max(Pf{t,k});%Potencia maxima de cada generador.
        Pideal(t,k)=Pnom*modenserie(t)*serie(k);%potencia nominal de cada generador.
        PsumaMAX(t,k)=max(Ptot(1,:))*(modenserie(t)*serie(k)-1)+max(Ptot(2,:));%Suma de potencias maximas de cada uno de los modulos de cada generador.
        PerdidasTOTf(t,k)=(Pideal(t,k)-Maxf(t,k))/Pideal(t,k);%Prdidas totales en cada generador aplicando la conexion "Paralelo de N modulos".
        PerdidasTOTf1(t,k)=(Pideal(t,k)-Maxf1(t,k))/Pideal(t,k);%Prdidas totales en cada generador sin aplicar ninguna conexion.
        DifPerdidasTOT(t,k)=PerdidasTOTf1(t,k)-PerdidasTOTf(t,k);% Diferencia de prdidas totales entre no aplicar ninguna conexion y aplicar la conexion "Paralelo de N modulos"
        PerdidasDISPf(t,k)=(PsumaMAX(t,k)-Maxf(t,k))/Pideal(t,k);%Prdidas por dispersin en cada generador aplicando la conexion "Paralelo de N modulos".
        PerdidasDISPf1(t,k)=(PsumaMAX(t,k)-Maxf1(t,k))/Pideal(t,k);%Prdidas por dispersin en cada generador sin aplicar ninguna conexion.
        DifPerdidasDISP(t,k)=PerdidasDISPf1(t,k)-PerdidasDISPf(t,k);%Prdidas por dispersin entre no aplicar ninguna conexion y aplicar la conexion "Paralelo de N modulos"
    end
end


%Dibuja las prdidas totales y las de dispersin al apliar y al no apliar la conexion "paralelode N modulos" 
    %as como la diferencia entre dichas prdidas en fucion del n de modulos en serie del generador y el n de series.

figure
[C,h]=contourf(X,Y,DifPerdidasTOT);%dif perdidas totales
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc-PerdidasTOTunac_entero(',nom,')']);%sinc -paralelo de N modulos"
figure
[C,h]=contourf(X,Y,PerdidasTOTf);%"paralelode N modulos" 
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTunac_entero(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTf1);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc(',nom,')']);

figure
[C,h]=contourf(X,Y,DifPerdidasDISP);%dif perdidas dispersion
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc-PerdidasDISP una conexion entero(',nom,')']);%sinc -"paralelode N modulos"
figure
[C,h]=contourf(X,Y,PerdidasDISPf); %"paralelode N modulos"
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISP una conexion entero(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPf1);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc(',nom,')']);

end




            
            
        
