function Paralelo_N_modulos_distintosMuestras(serie,modenserie,Pnom,nom)

%UTILIDAD:
    % Calcula las prdidas por dispersin de generadores de varias configuraciones (con todods los modulos distintos, creados mediante muestras aleatorias)
        %con la conexion "paralelo de N modulos" y tambien sin ella y las compara. 
    % Dibuja graficas de prdidas en funcion del n de modulos en serie y series.
    
%VARIABLES DE ENTRADA:
    %serie: vector con los numeros de series que se desean simular.
    %modenserie:vector con los numeros de modulos en serie que se desean simular.
    %nom:nombre del grupo de generadores simulado (para que aparzca en el titulo de las graficas)
    %Pnom: potencia nominal de los modulos.

warning off 

%Crea las matrices para "X"(series) y "Y"(modenseries) del grafico 3D.

cont=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        x(cont)=modenserie(i);
        z(cont)=serie(k);
        cont=cont+1;
    end
end
contador=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        X(k,i)=x(contador); %matriz de valores de modenserie. Cuando y=y{1,1} Y DifPot=DifPot{1,1} entonces el numero de modenserie es= a X{1,1}
        Y(k,i)=z(contador);
        contador=contador+1;
    end
end
    

%Lee los datos de todos los 36 modulos diferentes.
[V,I]= curvaIVnmodulos;

%Calcula la Pot en cada punto de la curva I-V de cada modulo.
mod=size(V,1);
for i=1:size(V,1)
    for t=1:size(V,2)
        P(i,t)=V(i,t)*I(i,t);
    end
end

%Duplica la cantidad de modulos disponibles cogiendo cada uno de los 36 dos veces, asi se tienen 72 modulos.
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
    P(mod+i,:)=P(i,:);
end


%Si se desea tener mas mosulos se tiene que repetir cada uno de los 36 mas veces. 
    %As se tendran 288 modulos (los 36 se han repetido 8 veces)
    
%mod=size(V,1);
%for i=1:mod
%    V(mod+i,:)=V(i,:);
%    I(mod+i,:)=I(i,:);
%    P(mod+i,:)=P(i,:);
%end

%mod=size(V,1);
%for i=1:mod
%    V(mod+i,:)=V(i,:);
%    I(mod+i,:)=I(i,:);
%    P(mod+i,:)=P(i,:);
%end


%Calcula la V la I y la P en cada punto de las curvas de cada uno de los generadores (cada uno con un configuracion diferente)
    %sin aplicarles ninguna conexion intermedia.

for i=1:length(modenserie)
    
   for t=1:length(serie)
       
       [Vsinc{t,i} Isinc{t,i}]= calculoseguidor2(V(1:modenserie(i)*serie(t),:),I(1:modenserie(i)*serie(t),:),serie(t),modenserie(i),(1:modenserie(i)*serie(t)));
       
       for p=1:length(Vsinc{t,i})
           Psinc{t,i}(1,p)=Vsinc{t,i}(1,p)*Isinc{t,i}(1,p);
       end

       PsincMAX(t,i)=max(Psinc{t,i});%Potencia maxima de cada generador.
   end
end



%Calcula la V la I y la P en cada punto de las curvas de cada uno de los generadores (cada uno con un configuracion diferente)
    %aplicandoles la conexion "Paralelo de N modulos".Separa en trozos.
    
%TROZOS es una matriz que contienen los las posiciones de los modulos.
    
    for i=1:length(serie)
        
        for t=1:length(modenserie)
            
            for g=1:modenserie(t)
                
                cont=1;
                TROZOS{i,t}(cont,g)=g;
                cont=cont+1;
                
                for p=1:serie(i)-1
                    TROZOS{i,t}(cont,g)=modenserie(t)*p+g;
                    cont=cont+1;
                end
            end
        end
    end

    %"Paralelo de N modulos":V,I de cada parte(trazo grande(sin modulo defectuoso) y trozo pequeo(con modulo defectuoso)).
    
      %Calcula la V y la I del trozo pequeo(modulos en paralelo con el defectuoso)para cada uno de los generadores:
      
      for i=1:length(serie)
          
        for t=1:length(modenserie)
            
            VTROZOp{i,t}=V(TROZOS{i,t}(1,end),:);
            ITROZOp{i,t}=I(TROZOS{i,t}(1,end),:);
            
            for g=2:size(TROZOS{i,t},1)
                [VTROZOp{i,t} ITROZOp{i,t}]=paralelo2stringsju(VTROZOp{i,t},ITROZOp{i,t},V(TROZOS{i,t}(g,end),:),I(TROZOS{i,t}(g,end),:));
            end
        end
      end
      
      %Calcula la V y la I del trozo grande(modulos sanos en serie y en paralelo, todos monis el ultimo de cada serie)para cada uno de los generadores:
      
      for i=1:length(serie)
          
        for t=1:length(modenserie)
            
            for p=1:serie(i)
                
                Vser{i,t}(p,:)=V(1+modenserie(t)*(p-1),:);
                Iser{i,t}(p,:)=I(1+modenserie(t)*(p-1),:);
                
                for q=2:modenserie(t)-1
                    
                    [Vser{i,t}(p,:) Iser{i,t}(p,:)]=serie2stringsju(Vser{i,t}(p,:),Iser{i,t}(p,:),V(1+modenserie(t)*(p-1)+(q-1),:),I(1+modenserie(t)*(p-1)+(q-1),:));
                end
                
                if p==1
                    
                    VTROZOg{i,t}=Vser{i,t}(p,:);
                    ITROZOg{i,t}=Iser{i,t}(p,:);
                else
                    
                    [VTROZOg{i,t} ITROZOg{i,t}]=paralelo2stringsju(VTROZOg{i,t},ITROZOg{i,t},Vser{i,t}(p,:),Iser{i,t}(p,:));
                end
            end
        end
      end
      
      
%Calcula de la V e I de cada generador al aplicar "Paralelo de N modulos"(union de las dos partes).

     for i=1:length(serie)
         
        for t=1:length(modenserie)
            
           [VGEN{i,t} IGEN{i,t}]=serie2stringsju(VTROZOp{i,t},ITROZOp{i,t},VTROZOg{i,t},ITROZOg{i,t});
           
            for p=1:length(VGEN{i,t})
                
                PGEN{i,t}(1,p)=VGEN{i,t}(1,p)*IGEN{i,t}(1,p);
            end
            
            PMAX(i,t)=max(PGEN{i,t});%Potencia de trabajo de cada generador al aplicar la conexion "paralelo de N modulos".
            Pideal(i,t)=Pnom*modenserie(t)*serie(i);%Potencia nominal de cada generador.
            PerdidasTOTsinc(i,t)=(Pideal(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas totales sin aplicar ninguna conexion intermedia de cada generador.
            PerdidasTOTunac_entero(i,t)=(Pideal(i,t)-PMAX(i,t))/Pideal(i,t);%Prdidas totales aplicando la conexion "paralelo de N modulos" para cad generador.
            DifPerdidasTOT(i,t)=PerdidasTOTsinc(i,t)-PerdidasTOTunac_entero(i,t);%Diferencia de prdidas totales entre no aplicar y aplicar la conxion "paralelo de N modulos" para cada generador.
        end
     end

     
     %Calculo de las prdidas por diapersin.
     
    for t=1:length(modenserie)
        
        empezar=1;
        
        for i=1:length(serie)
            
            if i==1 
                PsumaMAX(i,t)=0;
                
            else
                PsumaMAX(i,t)=PsumaMAX(i-1,t);
                
            end
            
            modulos=modenserie(t)*serie(i);
            
            for p=empezar:modulos
                PsumaMAX(i,t)=PsumaMAX(i,t)+max(P(p,:));
            end
            
            empezar=modulos+1;
            
            PerdidasDISPsinc(i,t)=(PsumaMAX(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas por dispersion en cada generador sin aplicar conexion intermedia.
            PerdidasDISPunac_entero(i,t)=(PsumaMAX(i,t)-PMAX(i,t))/Pideal(i,t);%Prdidas por dispersion en cada generador al aplicar la conexion "paralelo de N modulos".
            DifPerdidasDISP(i,t)=PerdidasDISPsinc(i,t)-PerdidasDISPunac_entero(i,t);%Diferencia de perdidas por dispersion al aplicar y al no aplicar la conexion "paralelo de N modulos".
        end
    end
     
figure
[C,h]=contourf(X,Y,DifPerdidasTOT);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc-PerdidasTOTunac_entero(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTunac_entero);%"paralelo de N modulos"
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTunac_entero(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc(',nom,')']);

%DISPERSION
figure
[C,h]=contourf(X,Y,DifPerdidasDISP);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc-PerdidasDIPSunacentero(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPunac_entero);%paralelo de N modulos"
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPunacentero(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc(',nom,')']);
end