function  RedPorParejas_distintosMuestras(serie,modenserie,Pnom,nom)

%UTILIDAD:
    % Calcula las prdidas por dispersin de generadores de varias configuraciones (con todods los modulos distintos, creados mediante muestras aleatorias)
        %con la conexion "Red por parejas" y tambien sin ella y las compara. 
    % Dibuja graficas de prdidas en funcion del n de modulos en serie y series.
    
%VARIABLES DE ENTRADA:
    %serie: vector con los numeros de series que se desean simular.
    %modenserie:vector con los numeros de modulos en serie que se desean simular.
    %nom:nombre del grupo de generadores simulado (para que aparzca en el titulo de las graficas)
    %Pnom: potencia nominal de los modulos.
    
    
warning off 

%Crea las matrices para "X"(series) y "Y"(modenseries) del grafico 3D.

cont=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        x(cont)=modenserie(i);
        z(cont)=serie(k);
        cont=cont+1;
    end
end
contador=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        X(k,i)=x(contador); %matriz de valores de modenserie. Cuando y=y{1,1} Y DifPot=DifPot{1,1} entonces el numero de modenserie es= a X{1,1}
        Y(k,i)=z(contador);
        contador=contador+1;
    end
end
    

%Lee los datos de todos los 36 modulos diferentes.
[V,I]= curvaIVnmodulos;

%Calcula la Pot en cada punto de la curva I-V de cada modulo.
mod=size(V,1);
for i=1:size(V,1)
    for t=1:size(V,2)
        P(i,t)=V(i,t)*I(i,t);
    end
end

%Duplica la cantidad de modulos disponibles cogiendo cada uno de los 36 dos veces, asi se tienen 72 modulos.
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
    P(mod+i,:)=P(i,:);
end

      
%Calcula la V la I y la P en cada punto de las curvas de cada uno de los generadores (cada uno con un configuracion diferente)
    %sin aplicarles ninguna conexion intermedia.
    
for i=1:length(modenserie)
    
   for t=1:length(serie)
       
       [Vsinc{t,i} Isinc{t,i}]= calculoseguidor2(V(1:modenserie(i)*serie(t),:),I(1:modenserie(i)*serie(t),:),serie(t),modenserie(i),(1:modenserie(i)*serie(t)));
       
       for p=1:length(Vsinc{t,i})
           Psinc{t,i}(1,p)=Vsinc{t,i}(1,p)*Isinc{t,i}(1,p);
       end
       
       PsincMAX(t,i)=max(Psinc{t,i});%Potencia de trabajo de cada generador sin aplicarle ninguna conexion.
   end
end



%Calcula la V la I y la P en cada punto de las curvas de cada uno de los generadores (cada uno con un configuracion diferente)
    %aplicandoles la conexion "Red por parejas".

%separo por grupos los modulos. en cada grupo estrn los modulos que hay entre conecion y conexion.

for t=1:length(modenserie)
    
    for i=1:length(serie)
         
        %Calcula el n de grupos que hay para esa configuracion.
            %Y pone "par" a uno si el n de modulos en serie es par y a 0 si es impar.
        numeroGrupos=fix(modenserie(t)/2);
        if numeroGrupos==modenserie(t)/2
            par=1;
        else
            par=0;
            numeroGrupos=numeroGrupos+1;
        end
       
        %Calcula la V y la I de cada grupo.
        for p=1:numeroGrupos
            
            for q=1:serie(i)%Para cada grupo, va calculando dos modulos en serie y los pone en paralelo con otros dos y asi progresivamente
                                %hasta completar las perejas de modulos de cada grupo(=n de series)
                
               empieza=(2*p-1)+modenserie(t)*(q-1);
               if par==0 && p==numeroGrupos %Si el n de modulos en serie es impar y esta calculando la V y la I del ultimo grupo.
                   
                  V2ser=V(empieza,:);
                  I2ser=I(empieza,:);
                  
               else
                   
                  [V2ser I2ser]=serie2stringsju(V(empieza,:),I(empieza,:),V(empieza+1,:),I(empieza+1,:));%Calcula los dos modulos en serie.
               end
               
               if q==1%Si solo se ha calculado una pareja de modulos en serie.
                   
                   VGrupo{p}=V2ser;
                   IGrupo{p}=I2ser;
                   
               else
                   [VGrupo{p} IGrupo{p}]=paralelo2stringsju(VGrupo{p},IGrupo{p},V2ser,I2ser);%Pone los dos modulos en serie en paralelo con el resto de parejas de su grupo.
               end
            end
            
            %Pone en paralelo los grupos para calcula la V y la I de cada generador al aplicar la conexion "Red por parejas".
            
            if p==1%Si solo se ha calculado un grupo.
                
                Vgen{i,t}=VGrupo{p};
                Igen{i,t}=IGrupo{p};
                
            else
                [Vgen{i,t} Igen{i,t}]=serie2stringsju(Vgen{i,t},Igen{i,t},VGrupo{p},IGrupo{p});
            end
        end  
         
        %Calcula la potencia de cada generador en cada punto de su curva.
        
        for w=1:length(Vgen{i,t})
            
             Pgen{i,t}(1,w)=Vgen{i,t}(1,w)*Igen{i,t}(1,w);
        end
        
             PmaxCADA2(i,t)=max(Pgen{i,t});%Potencia de trabajo de cada generador al aplicarle la conexion "Red por parejas".
             Pideal(i,t)=Pnom*modenserie(t)*serie(i);%Potencia nominal de cada generador.
             PerdidasTOTsinc(i,t)=(Pideal(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas totales de cada generador sin aplicar ninguna conexion.
             PerdidasTOTcada2(i,t)=(Pideal(i,t)-PmaxCADA2(i,t))/Pideal(i,t);%Prdidas totales de cada generador al aplicarle la conexion "Red por parejas".
             DifPerdidasTOT(i,t)=PerdidasTOTsinc(i,t)-PerdidasTOTcada2(i,t);%Diferencia de prdidas entre aplicar y no aplicar la conexion "Red por parejas".
    end
end

%Calculo de las prdidas por dispersin.

for t=1:length(modenserie)
    
        empezar=1;
        
        for i=1:length(serie)
            
            if i==1 
                PsumaMAX(i,t)=0;
                
            else
                PsumaMAX(i,t)=PsumaMAX(i-1,t);
            end
            
            modulos=modenserie(t)*serie(i);
            
            for p=empezar:modulos
                PsumaMAX(i,t)=PsumaMAX(i,t)+max(P(p,:));
            end
            
            empezar=modulos+1;
            
            PerdidasDISPsinc(i,t)=(PsumaMAX(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas por dispersin de cada generador sin aplicar ninguna conexion.
            PerdidasDISPcada2(i,t)=(PsumaMAX(i,t)-PmaxCADA2(i,t))/Pideal(i,t);%Prdidas por dispersin de cada generador al aplicarle la conexion "Red por parejas".
            DifPerdidasDISP(i,t)=PerdidasDISPsinc(i,t)-PerdidasDISPcada2(i,t);%Diferencia de prdidas entre aplicar y no aplicar la conexion "Red por parejas".
            
        end
    end
    
    
    
    
    
    %TOTALES
figure
[C,h]=contourf(X,Y,DifPerdidasTOT);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc-PerdidasTOT"Red por parejas"(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTcada2);%"Red por parejas"
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTcada2(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc(',nom,')']);

%DISPERSION
figure
[C,h]=contourf(X,Y,DifPerdidasDISP);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc-PerdidasDIPS"Red por parejas"(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPcada2);%"Red por parejas"
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPcada2(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc(',nom,')']);



end




            
            
        

          
            
            


