function  Red_distintosMuestras(serie,modenserie,Pnom,nom)

%UTILIDAD:
    % Calcula las prdidas por dispersin de generadores de varias configuraciones (con todods los modulos distintos, creados mediante muestras aleatorias)
        %con la conexion "Red" y tambien sin ella y las compara. 
    % Dibuja graficas de prdidas en funcion del n de modulos en serie y series.
    
%VARIABLES DE ENTRADA:
    %serie: vector con los numeros de series que se desean simular.
    %modenserie:vector con los numeros de modulos en serie que se desean simular.
    %nom:nombre del grupo de generadores simulado (para que aparzca en el titulo de las graficas)
    %Pnom: potencia nominal de los modulos.


warning off 

%Crea las matrices para "X"(series) y "Y"(modenseries) del grafico 3D.

cont=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        x(cont)=modenserie(i);
        z(cont)=serie(k);
        cont=cont+1;
    end
end
contador=1;
for i=1:length(modenserie)
    for k=1:length(serie)
        X(k,i)=x(contador); %matriz de valores de modenserie. Cuando y=y{1,1} Y DifPot=DifPot{1,1} entonces el numero de modenserie es= a X{1,1}
        Y(k,i)=z(contador);
        contador=contador+1;
    end
end
    

%Lee los datos de todos los 36 modulos diferentes.
[V,I]= curvaIVnmodulos;

%Calcula la Pot en cada punto de la curva I-V de cada modulo.
mod=size(V,1);
for i=1:size(V,1)
    for t=1:size(V,2)
        P(i,t)=V(i,t)*I(i,t);
    end
end

%Duplica la cantidad de modulos disponibles cogiendo cada uno de los 36 dos veces, asi se tienen 72 modulos.
for i=1:mod
    V(mod+i,:)=V(i,:);
    I(mod+i,:)=I(i,:);
    P(mod+i,:)=P(i,:);
end

      
%Calcula la V la I y la P en cada punto de las curvas de cada uno de los generadores (cada uno con un configuracion diferente)
    %sin aplicarles ninguna conexion intermedia.
    
for i=1:length(modenserie)
    
   for t=1:length(serie)
       
       [Vsinc{t,i} Isinc{t,i}]= calculoseguidor2(V(1:modenserie(i)*serie(t),:),I(1:modenserie(i)*serie(t),:),serie(t),modenserie(i),(1:modenserie(i)*serie(t)));
       
       for p=1:length(Vsinc{t,i})
           Psinc{t,i}(1,p)=Vsinc{t,i}(1,p)*Isinc{t,i}(1,p);
       end
       
       PsincMAX(t,i)=max(Psinc{t,i});%Potencia de trabajo de cada generador sin aplicarle ninguna conexion.
   end
end



%Calcula la V la I y la P en cada punto de las curvas de cada uno de los generadores (cada uno con un configuracion diferente)
    %aplicandoles la conexion "Red".Separa en trozos.
    
%TROZOS es una matriz que contienen los las posiciones de los modulos.

    for i=1:length(serie)
        
        for t=1:length(modenserie)
            
            for g=1:modenserie(t)
                
                cont=1;
                TROZOS{i,t}(cont,g)=g;
                cont=cont+1;
                
                for p=1:serie(i)-1
                    TROZOS{i,t}(cont,g)=modenserie(t)*p+g;
                    cont=cont+1;
                end
            end
        end
    end
    
%Calcula la V y la I de cada trozo en que quedan divididos los generadores al aplicarles la conexion "Red".

    for i=1:length(serie)
        
        for t=1:length(modenserie)
            
            for g=1:size(TROZOS{i,t},2)
                
                VTROZOS{i,t}(g,:)=V(TROZOS{i,t}(1,g),:);
                ITROZOS{i,t}(g,:)=I(TROZOS{i,t}(1,g),:);
                
                for p=2:size(TROZOS{i,t},1)
                    
                   [VTROZOS{i,t}(g,:) ITROZOS{i,t}(g,:)]=paralelo2stringsju(VTROZOS{i,t}(g,:),ITROZOS{i,t}(g,:),V(TROZOS{i,t}(p,g),:),I(TROZOS{i,t}(p,g),:));
                end
            end
        end
    end
    
%Calcula la V y la I de cada generador (union de trozos en serie).

    for i=1:length(serie)
        
        for t=1:length(modenserie)
            
            VGEN{i,t}=VTROZOS{i,t}(1,:);
            IGEN{i,t}=ITROZOS{i,t}(1,:);
            
            for g=2:size(VTROZOS{i,t},1)
                
                [VGEN{i,t} IGEN{i,t}]=serie2stringsju(VGEN{i,t},IGEN{i,t},VTROZOS{i,t}(g,:),ITROZOS{i,t}(g,:));
            end
            
            for p=1:length(VGEN{i,t})
                
                PGEN{i,t}(1,p)=VGEN{i,t}(1,p)*IGEN{i,t}(1,p);
            end
            
            PMAX(i,t)=max(PGEN{i,t});%Potencia de trabajo de cada generador al aplicarle la conexion "Red".
            Pideal(i,t)=Pnom*modenserie(t)*serie(i);%Potencia nominal de cada generador.
            PerdidasTOTsinc(i,t)=(Pideal(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas totales de cada generador sin aplicarles ninguna conexion.
            PerdidasTOTred(i,t)=(Pideal(i,t)-PMAX(i,t))/Pideal(i,t);%Prdidas totales de cada generador aplicandoles la conexion "Red".
            DifPerdidasTOT(i,t)=PerdidasTOTsinc(i,t)-PerdidasTOTred(i,t);%Diferencia dde prdidas al aplicar y al no aplicar la conexion "Red" en cada generador.
        end
    end

    
    %Calculo de las prdidas por dispersion.
    
    for t=1:length(modenserie)
        
        empezar=1;
        
        for i=1:length(serie)
            
            if i==1 
                PsumaMAX(i,t)=0;
                
            else
                PsumaMAX(i,t)=PsumaMAX(i-1,t);  
            end
            
            modulos=modenserie(t)*serie(i);
            
            for p=empezar:modulos
                
                PsumaMAX(i,t)=PsumaMAX(i,t)+max(P(p,:));
            end
            
            empezar=modulos+1;
            
            PerdidasDISPsinc(i,t)=(PsumaMAX(i,t)-PsincMAX(i,t))/Pideal(i,t);%Prdidas por dispersion de cada generador sin aplicarles ninguna conexion.
            PerdidasDISPred(i,t)=(PsumaMAX(i,t)-PMAX(i,t))/Pideal(i,t);%Prdidaspor dispersion de cada generador aplicandoles la conexion "Red".
            DifPerdidasDISP(i,t)=PerdidasDISPsinc(i,t)-PerdidasDISPred(i,t);%Diferencia de prdidas al aplicar y al no aplicar la conexion "Red" en cada generador.
            
        end
    end
    
    
    
    
    
    %TOTALES
figure
[C,h]=contourf(X,Y,DifPerdidasTOT);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc-PerdidasTOTred(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTred);%red
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTtodo(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasTOTsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasTOTsinc(',nom,')']);

%DISPERSION
figure
[C,h]=contourf(X,Y,DifPerdidasDISP);%dif.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc-PerdidasDIPSred(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPred);%red
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPtodo(',nom,')']);
figure
[C,h]=contourf(X,Y,PerdidasDISPsinc);%sinc.
clabel(C,h);
xlabel('n modulos en cada serie');
ylabel('nseries');
title(['PerdidasDISPsinc(',nom,')']);

end




            
            
        

          
            
            


