function Yingli_2defectuososDiferentesMismaSerie10sx4p(D,segui,Ndefectuoso1,Ndefectuoso2)

%UTILIDAD:

%Crea un generador 10sx4p con todos sus modulos iguales excepto dos defectusos diferentes en una misma serie. Uso destinado a modulos Yingli.
    %Dibuja las curvas I-V de sus modulos y sus puntos de trabajo.
    %Crea una hoja excel con los datos de potencia generada y perdias por dispersion y totales.

%VARIABLES DE ENTRADA:

%D: contiene los datos en excel de los modulos.
%segui: nombre de la carpeta en que estn los datos. En este caso 'Modulos
%Yings'.
%Ndefectuoso1: numero asignado al modulo defectusos 1 en la hoja excel de los Yings (4, 5, 6 o 1)
%Ndefectuoso2: numero asignado al modulo defectusos 2 en la hoja excel delos Yings (4, 5, 6 o 1).
%Pnom: potencia nominal de los modulos que forman el generador. (170 en Yings, pero en este caso se considera la Pmax la del modulo perfecto, asi que no se toma como variable de entrada.)


warning off

%Prepara la grafica para despues dibujar en ella.

figure
hold on
xlabel('Tensin (V)');
ylabel('Corriente (A), Potencia(W/18)');
nombredatos=D(1).name;

%Lee los valores de V e I del modulo Yingli perfecto y del modulo Yingli defectuoso.

ModPerfecto=2;
nombre=['Modulo',num2str(ModPerfecto)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:101,:);

    V(:,1)=N(:,21);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
    I(:,1)=N(:,22);
    
    
    
ModDefecto=Ndefectuoso1;
nombre=['Modulo',num2str(ModDefecto)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:101,:);

    V(:,2)=N(:,21);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
    I(:,2)=N(:,22);
    
    
ModDefecto=Ndefectuoso2;
nombre=['Modulo',num2str(ModDefecto)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:101,:);

    V(:,3)=N(:,21);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
    I(:,3)=N(:,22);
    
    
VV=V';
II=I';

%Calcula la potencia en cada punto de la curva de los dos modulos.

for i=1:size(VV,1)
    for t=1:size(VV,2)
        PP(i,t)=VV(i,t)*II(i,t);
    end
end

%Divide la potencia entre 18 para representar mejor.

for i=1:size(PP,1)
    for t=1:size(PP,2)
        PP15(i,t)=PP(i,t)/18;
    end
end

%Crea un vector V,I, o P tot con los datos de todos los modulos del generador (38 iguales y dos defectuosos diferentes)
    
for i=1:38
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

Vtot(39,:)=VV(2,:);
Itot(39,:)=II(2,:);
Ptot(39,:)=PP(2,:);

Vtot(40,:)=VV(3,:);
Itot(40,:)=II(3,:);
Ptot(40,:)=PP(3,:);

%Dibuja las curvas I-V del modulo efectuoso y de un modulo perfecto con sus puntos de maxima potencia.


plot(VV(1,:),II(1,:));
plot(VV(2,:),II(2,:),'r');
plot(VV(3,:),II(3,:),'r');
for i=1:size(PP15,1)
    for t=2:size(PP15,2)
        if PP15(i,t)==max(PP15(i,:))
            lugar{i}=t;
        end
    end
end
plot(VV(1,:),PP15(1,:),'b--')
plot(VV(2,:),PP15(2,:),'r--')
plot(VV(3,:),PP15(3,:),'r--')
plot(VV(1,lugar{1}),II(1,lugar{1}),'b*');
plot(VV(2,lugar{2}),II(2,lugar{2}),'b*');
plot(VV(3,lugar{3}),II(3,lugar{3}),'b*');
plot(VV(1,lugar{1}),PP15(1,lugar{1}),'b*');
plot(VV(2,lugar{2}),PP15(2,lugar{2}),'b*');
plot(VV(3,lugar{3}),PP15(3,lugar{3}),'b*');



%Calcula la V y la I del seguidor.

[Vsegui Isegui Vseries Iseries]= calculoseguidor2(Vtot,Itot,4,10,(1:40));

for i=1:size(Vsegui,2)
    Psegui(1,i)=Vsegui(1,i)*Isegui(1,i);
end

%Calcula los puntos de trabajo de cada tipo de modulo.

for i=1:size(Psegui,2)
    if Psegui(1,i)==max(Psegui)
        lugar=i;
    end
end

Vserreal=Vsegui(1,lugar);

for i=1:4 %tantas veces como series halla.
    [Iserreal(i,:)]=extrapola2ju(Vseries(i,:),Iseries(i,:),Vserreal);
end

    %Todos los modulos del "resto de modulos" trabajan en el mismo punto de trabajo.
[Vmodreal{1}]=extrapola2ju(Itot(1,:),Vtot(1,:),Iserreal(1,:));

    %Todos los modulos de "misma serie" trabajan en el mismo punto.
[Vmodreal{31}]=extrapola2ju(Itot(31,:),Vtot(31,:),Iserreal(4,:));

[Vmodreal{39}]=extrapola2ju(Itot(39,:),Vtot(39,:),Iserreal(4,:));

[Vmodreal{40}]=extrapola2ju(Itot(40,:),Vtot(40,:),Iserreal(4,:));

%Dibuja los puntos de trabajo.
plot(Vmodreal{1},Iserreal(1,:),'bo');
plot(Vmodreal{31},Iserreal(4,:),'ko');
plot(Vmodreal{39},Iserreal(4,:),'ro');
plot(Vmodreal{40},Iserreal(4,:),'ro');


%Calcula las perdidas por dispersion y totales del generador.

SumaPmax=max(Ptot(1,:))*38+max(Ptot(40,:)+max(Ptot(39,:)));
PnomGen=max(Ptot(1,:))*40;

PerdidasDISP=(SumaPmax-max(Psegui))/PnomGen;
PerdidasTOT=(PnomGen-max(Psegui))/PnomGen;

%Calcula las perdidas por dispersion y totales de cada tipo de modulo.

PerdidasDISPmodDEF1=(max(Ptot(40,:))-Vmodreal{40}*Iserreal(4,:))/max(Ptot(1,:));
PerdidasDISPmodDEF2=(max(Ptot(39,:))-Vmodreal{39}*Iserreal(4,:))/max(Ptot(1,:));
PerdidasDISPmodMISMA=(max(Ptot(1,:))-Vmodreal{31}*Iserreal(4,:))/max(Ptot(1,:));
PerdidasDISPmodRESTO=(max(Ptot(1,:))-Vmodreal{1}*Iserreal(1,:))/max(Ptot(1,:));

PerdidasTOTmodDEF1=(max(Ptot(1,:))-Vmodreal{40}*Iserreal(4,:))/max(Ptot(1,:));
PerdidasTOTmodDEF2=(max(Ptot(1,:))-Vmodreal{39}*Iserreal(4,:))/max(Ptot(1,:));


%Pone los datos en una hoja excel.

celda{1,1}=['MDULO DEF:',num2str(Ndefectuoso1),'y',num2str(Ndefectuoso2)];
celda{1,2}='Pnom';
celda{1,3}='Suma de Pot. maximas';
celda{1,4}='Potencia de trabajo';
celda{1,5}='PERDIDAS POR DISPERSION';
celda{1,6}='PERDIDAS TOTALES';

celda{2,1}='Generador';
celda{3,1}='Mdulo defectuoso1';
celda{4,1}='Mdulo defectuoso2';
celda{5,1}='Mdulos misma serie';
celda{6,1}='Resto de mdulos';

celda{2,2}=PnomGen;
celda{2,3}=SumaPmax;
celda{2,4}=max(Psegui);
celda{2,5}=PerdidasDISP;
celda{2,6}=PerdidasTOT;

celda{3,2}=max(Ptot(1,:));
celda{3,3}=max(Ptot(40,:));
celda{3,4}=Vmodreal{40}*Iserreal(4,:);
celda{3,5}=PerdidasDISPmodDEF1;
celda{3,6}=PerdidasTOTmodDEF1;


celda{4,2}=max(Ptot(1,:));
celda{4,3}=max(Ptot(39,:));
celda{4,4}=Vmodreal{39}*Iserreal(4,:);
celda{4,5}=PerdidasDISPmodDEF2;
celda{4,6}=PerdidasTOTmodDEF2;


celda{5,2}=max(Ptot(1,:));
celda{5,3}=max(Ptot(1,:));
celda{5,4}=Vmodreal{31}*Iserreal(4,:);
celda{5,5}=PerdidasDISPmodMISMA;


celda{6,2}=max(Ptot(1,:));
celda{6,3}=max(Ptot(1,:));
celda{6,4}=Vmodreal{1}*Iserreal(1,:);
celda{6,5}=PerdidasDISPmodRESTO;


rango='A1';
nombre_hoja=[num2str(Ndefectuoso1),',',num2str(Ndefectuoso2),'Modulo defectuoso'];
xlswrite(['C:\Users\usuario\Desktop\pfc\pfc\ModYingli2def mismaser Distints10sx4p'],celda,nombre_hoja,rango);
    
end



