function Yingli_Strings10sx4p(D,segui,NumDef,ser1,ser2,ser3,ser4,ponertitulos,ordenExcel)

%Calcula las prdidas en un generador en funcion de n de "strings" deteriorados en cada serie.
    %Dibuja las curva de los strings y sus puntos de trabajo.
    %Pone los datos en una hoja excel.
    
%D, contiene los datos de los modulos Yingli.
%segui, nombre de la carpeta en dode stan los datos. "Modulos Yingli".
%NumDef: numero del generador a analizar.
%serX=numero de modulos defectuosos en la serie X.
%ponertitulos=1 si es el primer generador que aparace en la hija excel, o si no hace falta, poruqe ya se ha puesto en el primero
%ordenExcel=para poner el rango bien, si es el primero que se pone en la hoja, serie1, si es el segundo 2 y as.

warning off

%Lee los valores de V e I del modulo Yingli perfecto y del modulo Yingli defectuoso.

nombredatos=D(1).name;
ModPerfecto=2;%lee el modulo perfecto.
nombre=['Modulo',num2str(ModPerfecto)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:101,:);

    V(:,1)=N(:,21);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
    I(:,1)=N(:,22);
    
    
    
ModDefecto=3;%lee el modulo con defecto leve.
nombre=['Modulo',num2str(ModDefecto)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:101,:);

    V(:,2)=N(:,21);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
    I(:,2)=N(:,22);
    

VV=V';
II=I';

%Calcula la potencia en cada punto de la curva de los dos modulos.

for i=1:size(VV,1)
    for t=1:size(VV,2)
        PP(i,t)=VV(i,t)*II(i,t);
        if PP(i,t)==max(PP(i,:))
            lugarMOD(i)=t;
        end
    end
end

%Divide la potencia entre 18 para representar mejor.

for i=1:size(PP,1)
    for t=1:size(PP,2)
        PP18(i,t)=PP(i,t)/18;
    end
end

%Crea un vector V,I, o P tot con los datos de todos los modulos del generador (a cada serie le corresponde un n de modulos defectuosos)

for i=1:10-ser1
    
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

for i=10-ser1+1:10
    
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end

for i=11:20-ser2
    
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

for i=20-ser2+1:20
    
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end

for i=21:30-ser3
    
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

for i=30-ser3+1:30
    
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end

for i=31:40-ser4
    
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

for i=40-ser4+1:40
    
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end

%calculo la potencia del generador.

[Vsegui Isegui Vseries Iseries]= calculoseguidor2(Vtot,Itot,4,10,(1:40));

for i=1:size(Vsegui,2)
    Psegui(1,i)=Vsegui(1,i)*Isegui(1,i);
end

maxPsegui=max(Psegui);

%Calcula prdidas por dispersion y totales.

SumaPmax=max(PP(2,:))*(ser1+ser2+ser3+ser4)+max(PP(1,:))*(40-ser1-ser2-ser3-ser4);
PnomGen=max(PP(1,:))*40;
PerdDISP=(SumaPmax-max(Psegui))/PnomGen;
PerdTOT=(PnomGen-max(Psegui))/PnomGen;

%Dibuja los "strings" y sus puntos de trabajo.

   %Hallo los valores de tension del modulo perfecto y del def para los mismos puntos de corriente.
        
    Ijuntas=sort([II(1,:) II(2,:)]);     % agrupamos las corrientes de los dos strings
    Ijuntas=Ijuntas((end:-2:1));         % y cogemos slo una de cada dos
    for i=1:length(Ijuntas)              %quitamos los valores de I que no pertenecen al rango de tensiones conocidos de ambos modulos, para evitar problemas.
        if Ijuntas(i)>II(1,1)
            quitar=i;
        end
        if Ijuntas(i)>II(2,1)
            quitar=i;
        end
    end
   
    Ijuntas=Ijuntas(quitar+1:end);
    for i=1:size(Ijuntas,2)
       
       [VVj(1,i)]=extrapola2ju(II(1,:),VV(1,:),Ijuntas(1,i));
       [VVj(2,i)]=extrapola2ju(II(2,:),VV(2,:),Ijuntas(1,i));
    end
    
    %Los escribo en excel, por verlos.
    
    %celda1{1,1}='Tension (V) (MODULO 2,igualado)';
    %celda1{1,2}='Corriente (A) (MODULO 2,igualado)';
    %celda1{1,3}='Tension (V) (MODULO 3,igualado)';
    % celda1{1,4}='Corriente (A) (MODULO3,igualado)';
     
    % for i=1:size(VVj,2)
    %     celda1{i+1,1}=VVj(1,i);
    %     celda1{i+1,2}=Ijuntas(1,i);
    %     celda1{i+1,3}=VVj(2,i);
    %     celda1{i+1,4}=Ijuntas(1,i);
    % end
         
   % rango='A1';
   % nombre_hoja='Yingli';
   % xlswrite('C:\Users\usuario\Desktop\pfc\pfc\YINGLI IGUALADOS',celda1,nombre_hoja,rango);
     
    %Dibuja el modulo defe y el perf en una figura aparte.POR VER
    %figure
    %hold on
    %xlabel('Tensin (V)');
    %ylabel('Corriente (A), Potencia(W/5)');
    %title([num2str(NumDef),' strings def. (',num2str(ser1),',',num2str(ser2),',',num2str(ser3),',',num2str(ser4),')']);
    
    %plot(VVj(1,:),Ijuntas(1,:),'b');
    %plot(VVj(2,:),Ijuntas(1,:),'r');
    
   %Hallo las tensiones de cada string para esas corrientes.
   
   for i=1:size(VVj,2)
       VVs(1,i)=VVj(1,i)/3;
       VVs2(1,i)=VVs(1,i)*2;
       VVs(2,i)=VVj(2,i)- VVs2(1,i);
   end
       
    IIs(1,:)=Ijuntas;
    IIs(2,:)=Ijuntas;
    
    for i=1:size(VVs,1)
    for t=1:size(VVs,2)
        PPs(i,t)=VVs(i,t)*Ijuntas(t);
        if PPs(i,t)==max(PPs(i,:))
            lugarSTRING(i)=t;
        end
    end
end

for i=1:size(PPs,1)
    for t=1:size(PPs,2)
        PP5s(i,t)=PPs(i,t)/5;
    end
end
 

     figure
    hold on
    xlabel('Tensin (V)');
    ylabel('Corriente (A), Potencia(W/5)');
    title([num2str(NumDef),' strings def. (',num2str(ser1),',',num2str(ser2),',',num2str(ser3),',',num2str(ser4),')']);
    
    
%Alargo las curva I-V del string def. porque para tensiones pequeas no tengo valores extrapolados.

VVsPER(1)=0;
IIsPER(1)=IIs(1,1);
PPsPER(1)=(VVsPER(1)*IIsPER(1))/5;

for i=1:size(VVs,2)
    
    VVsPER(i+1)=VVs(1,i);
    IIsPER(i+1)=IIs(1,i);
    PPsPER(i+1)=(VVsPER(i+1)*IIsPER(i+1))/5;
end

plot(VVsPER,IIsPER,'b');
plot(VVs(2,:),IIs(2,:),'r');
plot(VVs(1,lugarSTRING(1)),IIs(1,lugarSTRING(1)),'b*');
plot(VVs(2,lugarSTRING(2)),IIs(2,lugarSTRING(2)),'b*');

plot(VVsPER,PPsPER,'b--');
plot(VVs(2,:),PP5s(2,:),'r--');
plot(VVs(1,lugarSTRING(1)),PP5s(1,lugarSTRING(1)),'b*');
plot(VVs(2,lugarSTRING(2)),PP5s(2,lugarSTRING(2)),'b*');

%Para dibujar puntos de trabajo calcula la corriente en cada serie.

 for i=1:size(Psegui,2)
        if Psegui(1,i)==max(Psegui)
            lugarGen=i;
        end
 end
 
 Vserreal=Vsegui(1,lugarGen);
    
 [Iserie1]=extrapola2ju(Vseries(1,:),Iseries(1,:),Vserreal);
 [Iserie2]=extrapola2ju(Vseries(2,:),Iseries(2,:),Vserreal);
 [Iserie3]=extrapola2ju(Vseries(3,:),Iseries(3,:),Vserreal);
 [Iserie4]=extrapola2ju(Vseries(4,:),Iseries(4,:),Vserreal);
 
 %Puntos de trabajo 
 
 if ser1==0
     
     [VstringPer1]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie1);
     plot(VstringPer1,Iserie1,'bo');
     VstringDef1=0;
     
 elseif ser1==10
     
     [VstringDef1]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie1);
     plot(VstringDef1,Iserie1,'bo');
     VstringPer1=0;
 else
     
     [VstringPer1]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie1);
     [VstringDef1]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie1);
     plot(VstringPer1,Iserie1,'bo');
     plot(VstringDef1,Iserie1,'bo');
 end

if ser2==0
    
     [VstringPer2]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie2);
      plot(VstringPer2,Iserie2,'ro');
      VstringDef2=0;
      
 elseif ser2==10
     
     [VstringDef2]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie2);
     plot(VstringDef2,Iserie2,'ro');
     VstringPer2=0;
     
else
     
     [VstringPer2]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie2);
     [VstringDef2]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie2);
      plot(VstringPer2,Iserie2,'ro');
      plot(VstringDef2,Iserie2,'ro');
end

 if ser3==0
     
     [VstringPer3]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie3);
     plot(VstringPer3,Iserie3,'ko');
     VstringDef3=0;
     
 elseif ser3==10
     
     [VstringDef3]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie3);
     plot(VstringDef3,Iserie3,'ko');
     VstringPer3=0;
     
 else
     
     [VstringPer3]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie3);
     [VstringDef3]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie3);
     plot(VstringPer3,Iserie3,'ko');
     plot(VstringDef3,Iserie3,'ko');
 end

 if ser4==0
     
     [VstringPer4]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie4);
     plot(VstringPer4,Iserie4,'go');
     VstringDef4=0;
     
 elseif ser1==10
     
     [VstringDef4]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie4);
      plot(VstringDef4,Iserie4,'go');
      VstringPer4=0;
      
 else
     
     [VstringPer4]=extrapola2ju(IIs(1,:),VVs(1,:),Iserie4);
     [VstringDef4]=extrapola2ju(IIs(2,:),VVs(2,:),Iserie4);
     plot(VstringPer4,Iserie4,'go');
      plot(VstringDef4,Iserie4,'go');
 end


 %Pone los datos en hoja excel.

if ponertitulos==1
    celda{1,3}='Pnom';
    celda{1,4}='Suma de Pot. maximas';
    celda{1,5}='Potencia de trabajo';
    celda{1,6}='PERDIDAS POR DISPERSION';
    celda{1,7}='PERDIDAS TOTALES';
end

celda{2,1}=[num2str(NumDef),'strings defectuosos'];
celda{3,1}=['ser1: ',num2str(ser1),'    ser2: ',num2str(ser2),'    ser3: ',num2str(ser3),'    ser4: ',num2str(ser4)];

celda{2,3}=PnomGen;
celda{2,4}=SumaPmax;
celda{2,5}=max(Psegui);
celda{2,6}=PerdDISP;
celda{2,7}=PerdTOT;

celda{4,2}='Generador';
celda{5,2}='Strig Def ser1';
celda{6,2}='Strig Def ser2';
celda{7,2}='Strig Def ser3';
celda{8,2}='Strig Def ser4';
celda{9,2}='Strig Per ser1';
celda{10,2}='Strig Per ser2';
celda{11,2}='Strig Per ser3';
celda{12,2}='Strig Per ser4';


VstringDef=[VstringDef1 VstringDef2 VstringDef3 VstringDef4];
VstringPer=[VstringPer1 VstringPer2 VstringPer3 VstringPer4];

celda{4,3}=max(PPs(1,:))*120;
celda{4,4}=max(PPs(1,:))*(120-ser1-ser2-ser3-ser4)+max(PPs(2,:))*(ser1+ser2+ser3+ser4);
celda{4,5}=max(Psegui);
celda{4,6}=(celda{4,4}-celda{4,5})/celda{4,3};
celda{4,7}=(celda{4,3}-celda{4,5})/celda{4,3};

for i=1:4
   celda{4+i,3}=max(PPs(1,:));
   celda{4+i,4}=max(PPs(2,:));
   celda{4+i,5}=VstringDef(i);
   celda{4+i,6}=(celda{4+i,4}-celda{4+i,5})/celda{4+i,3};
   celda{4+i,7}=(celda{4+i,3}-celda{4+i,5})/celda{4+i,3};
   
   celda{8+i,3}=max(PPs(1,:));
   celda{8+i,4}=max(PPs(1,:));
   celda{8+i,5}=VstringPer(i);
   celda{8+i,6}=(celda{8+i,4}-celda{8+i,5})/celda{8+i,3};
   celda{8+i,7}=(celda{8+i,3}-celda{8+i,5})/celda{8+i,3};
end

rango=['A',num2str((ordenExcel-1)*12+1)]; %Para usar si quiero poner tb las perdidas en los strings.
%rango=['A',num2str((ordenExcel-1)*3+1)]; %Para usar si solo quiero perdidas en el generador.
nombre_hoja='Yingli';
%xlswrite('C:\Users\usuario\Desktop\pfc\pfc\16genYingliExtremos2',celda,nombre_hoja,rango);

%escribirExcel_stringsYmodulos(VVj,Ijuntas,VVs);% para poner en excel los datos de strings y modulos extrapolados.
end







