function Yingli_VariosDefSeries10sx4p(D,segui,NumGen,ser1,ser2,ser3,ser4)

%UTILIDAD:

%Calcula las prdidas por dispersion y totales en 16 generadores, sabiendo cuantos modulos defectuosos(todos iguales) hay en cada serie.
    %Pone los datos en una hoja excel.
    %Dibuja las curvas I-V de las series.

%VARIABLES DE ENTRADA:

%D, contiene los datos de los modulos Yingli.
%segui, nombre de la carpeta en dode stan los datos. "Modulos Yingli".
%NumGen: numero del generador a analizar.
%serX=numero de modulos defectuosos en la serie X.


warning off

%Prepara la grafica para despues dibujar en ella.

figure
hold on
xlabel('Tensin (V)');
ylabel('Corriente (A), Potencia(W/18)');
nombredatos=D(1).name;

%Lee los valores de V e I del modulo Yingli perfecto y del modulo Yingli defectuoso.

ModPerfecto=2;%lee el modulo perfecto.
nombre=['Modulo',num2str(ModPerfecto)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:101,:);

    V(:,1)=N(:,21);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
    I(:,1)=N(:,22);
    
    
    
ModDefecto=3;%lee el modulo con defecto leve.
nombre=['Modulo',num2str(ModDefecto)];
[N,T]=xlsread(['C:\Users\usuario\Desktop\pfc\para matlab\',segui,'\',nombredatos],nombre);%N=vector columna con lod datos de cada modulo.
N=N(1:101,:);

    V(:,2)=N(:,21);    %V matriz, filas:numero de modulo,columnas:numero de medidas.
    I(:,2)=N(:,22);
    

VV=V';
II=I';

%Calcula la potencia en cada punto de la curva de los dos modulos.

for i=1:size(VV,1)
    for t=1:size(VV,2)
        PP(i,t)=VV(i,t)*II(i,t);
        if PP(i,t)==max(PP(i,:))
            lugarMOD(i)=t;
        end
    end
end

%Divide la potencia entre 18 para representar mejor.

for i=1:size(PP,1)
    for t=1:size(PP,2)
        PP18(i,t)=PP(i,t)/18;
    end
end

%Crea un vector V,I, o P tot con los datos de todos los modulos del generador (a cada serie le corresponde un n de modulos defectuosos)

for i=1:10-ser1
    
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

for i=10-ser1+1:10
    
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end

for i=11:20-ser2
    
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end
for i=20-ser2+1:20
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end
for i=21:30-ser3
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

for i=30-ser3+1:30
    
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end
for i=31:40-ser4
    Vtot(i,:)=VV(1,:);
    Itot(i,:)=II(1,:);
    Ptot(i,:)=PP(1,:);
end

for i=40-ser4+1:40
    
    Vtot(i,:)=VV(2,:);
    Itot(i,:)=II(2,:);
    Ptot(i,:)=PP(2,:);
end

%calculo la potencia del generador.

[Vsegui Isegui Vseries Iseries]= calculoseguidor2(Vtot,Itot,4,10,(1:40));

for i=1:size(Vsegui,2)
    Psegui(1,i)=Vsegui(1,i)*Isegui(1,i);
end

maxPsegui=max(Psegui);

%Calcula prdidas por dispersion y totales.

SumaPmax=max(PP(2,:))*(ser1+ser2+ser3+ser4)+max(PP(1,:))*(40-ser1-ser2-ser3-ser4);
PnomGen=max(PP(1,:))*40;
PerdDISP=(SumaPmax-max(Psegui))/PnomGen;
PerdTOT=(PnomGen-max(Psegui))/PnomGen;

%Pone los datos en hoja excel.

celda{2,1}=['GENERADOR',num2str(NumGen)];
celda{3,1}=['ser1: ',num2str(ser1),'    ser2: ',num2str(ser2),'    ser3: ',num2str(ser3),'    ser4: ',num2str(ser4)];

celda{2,2}=PnomGen;
celda{2,3}=SumaPmax;
celda{2,4}=max(Psegui);
celda{2,5}=PerdDISP;
celda{2,6}=PerdTOT;

if NumGen>16
    NumGen=NumGen-16;
end

if NumGen==1
    celda{1,2}='Pnom';
    celda{1,3}='Suma de Pot. maximas';
    celda{1,4}='Potencia de trabajo';
    celda{1,5}='PERDIDAS POR DISPERSION';
    celda{1,6}='PERDIDAS TOTALES';
end

rango=['A',num2str(3*(NumGen-1)+1)];
nombre_hoja='16GenYingli';
xlswrite('C:\Users\usuario\Desktop\pfc\pfc\16genYingliExtremos2',celda,nombre_hoja,rango);
 

%Dibuja las curvas I-V de las series.

hold on
plot(Vseries(1,:),Iseries(1,:),'b');
plot(Vseries(2,:),Iseries(2,:),'r');
plot(Vseries(3,:),Iseries(3,:),'k');
plot(Vseries(4,:),Iseries(4,:),'m');


    %Calcula el punto de maxima potencia de cada una.
    
    for i=1:length(Vseries(1,:))
        
        Pseries18(1,i)=(Vseries(1,i)*Iseries(1,i))/180;
        
        if Pseries18(1,i)==max(Pseries18(1,:))
            lugar(1)=i;
        end
        
        Pseries18(2,i)=(Vseries(2,i)*Iseries(2,i))/180;
        
        if Pseries18(2,i)==max(Pseries18(2,:))
            lugar(2)=i;
        end
        
        Pseries18(3,i)=(Vseries(3,i)*Iseries(3,i))/180;
        
        if Pseries18(3,i)==max(Pseries18(3,:))
            lugar(3)=i;
        end
        
        Pseries18(4,i)=(Vseries(4,i)*Iseries(4,i))/180;
        
        if Pseries18(4,i)==max(Pseries18(4,:))
            lugar(4)=i;
        end
    end
    
    plot(Vseries(1,:),Pseries18(1,:),'b--');
    plot(Vseries(2,:),Pseries18(2,:),'r--');
    plot(Vseries(3,:),Pseries18(3,:),'k--');
    plot(Vseries(4,:),Pseries18(4,:),'m--');
    
    plot(Vseries(1,lugar(1)),Iseries(1,lugar(1)),'b*');
    plot(Vseries(2,lugar(2)),Iseries(2,lugar(2)),'b*');
    plot(Vseries(3,lugar(3)),Iseries(3,lugar(3)),'b*');
    plot(Vseries(4,lugar(4)),Iseries(4,lugar(4)),'b*');
    plot(Vseries(1,lugar(1)),Pseries18(1,lugar(1)),'b*');
    plot(Vseries(2,lugar(2)),Pseries18(2,lugar(2)),'b*');
    plot(Vseries(3,lugar(3)),Pseries18(3,lugar(3)),'b*');
    plot(Vseries(4,lugar(4)),Pseries18(4,lugar(4)),'b*');
    
    %Calcula el punto de trabajo de las series.
    
    for i=1:size(Psegui,2)
        
        if Psegui(1,i)==max(Psegui)
            lugarGen=i;
        end
    end
    
    Vserreal=Vsegui(1,lugarGen);
    
    [Iserie1]=extrapola2ju(Vseries(1,:),Iseries(1,:),Vserreal);
    [Iserie2]=extrapola2ju(Vseries(2,:),Iseries(2,:),Vserreal);
    [Iserie3]=extrapola2ju(Vseries(3,:),Iseries(3,:),Vserreal);
    [Iserie4]=extrapola2ju(Vseries(4,:),Iseries(4,:),Vserreal);
    
     plot(Vserreal,Iserie1,'bo');
     plot(Vserreal,Iserie2,'ro');
     plot(Vserreal,Iserie3,'ko');
     plot(Vserreal,Iserie4,'mo');
     
     %Dibuja una series sin modulo defectuoso, para ver la deformacion de las dems.
     
     for i=1:10
         
         Vperfectos(i,:)=VV(1,:);
         Iperfectos(i,:)=II(1,:);
     end
     
     [VseriePer,IseriePer]=serieNSstringsju(Vperfectos,Iperfectos);
     
     plot(VseriePer,IseriePer,'k--');
     
     for i=1:length(VseriePer)
         PseriePer(1,i)=VseriePer(1,i)*IseriePer(1,i);
         if PseriePer(1,i)==max(PseriePer)
             lugarPer=i;
         end
     end
    
     plot(VseriePer(1,lugarPer),IseriePer(1,lugarPer),'b*');
     
     % Dibuja las curvas I-V de los strings: los defectuosos y los de susseries. No se tienen acceso directo a los daots de cada string, sino a un modulo con un string deteriorado o todos sanos.
     
     figure
     hold on
     plot(VV(1,:),II(1,:),'b');
     plot(VV(2,:),II(2,:),'r');
     plot(VV(1,:),PP18(1,:),'b--');
     plot(VV(2,:),PP18(2,:),'r--');
     plot(VV(1,lugarMOD(1)),II(1,lugarMOD(1)),'b*');
     plot(VV(2,lugarMOD(2)),II(2,lugarMOD(2)),'b*');
     plot(VV(1,lugarMOD(1)),PP18(1,lugarMOD(1)),'b*');
     plot(VV(2,lugarMOD(2)),PP18(2,lugarMOD(2)),'b*');
     
     if ser1==0
         
         [Vdef]=extrapola2ju(II(1,:),VV(1,:),Iserie1);
         plot(Vdef,Iserie1,'ro');
     else
         
         [Vdef]=extrapola2ju(II(2,:),VV(2,:),Iserie1);
         plot(Vdef,Iserie1,'ro');
     end
     
     if ser2==0
         
         [Vdef]=extrapola2ju(II(1,:),VV(1,:),Iserie2);
         plot(Vdef,Iserie2,'bo');
     else
         
         [Vdef]=extrapola2ju(II(2,:),VV(2,:),Iserie2);
         plot(Vdef,Iserie2,'bo');
     end
     
     if ser3==0
         
         [Vdef]=extrapola2ju(II(1,:),VV(1,:),Iserie3);
         plot(Vdef,Iserie3,'ko');
     else
         
         [Vdef]=extrapola2ju(II(2,:),VV(2,:),Iserie3);
         plot(Vdef,Iserie3,'ko');
     end
     
     if ser4==0
         
         [Vdef]=extrapola2ju(II(1,:),VV(1,:),Iserie4);
         plot(Vdef,Iserie4,'go');
     else
         
         [Vdef]=extrapola2ju(II(2,:),VV(2,:),Iserie4);
         plot(Vdef,Iserie4,'go');
     end
        
end