function [V,I]= curvaIVnmodulos
                  
%UTILIDAD:
    %Crea los datos de modulos mediante el mtodo de Newton-Raphson.
    
    
    
	
    %parametros del metodo de Newton-Raphson:
	
	delta=  0.00001;        % tolerancia para Ix0
	epsilon= 0.00001;       % tolerancia para los valores de la funcion f(V,I)
	max1=50;                % numero maximo de iteraciones    

    
    % Cargamos los parametros de la curva
    
    [c,vt,Rp,e,k,mv,Isv,Rsv,Ilv,vo]=cargarparametros;
    
    % Parametros para un modulo concreto
        Ix0 = 0;
        Vx0 = vo;                            % valor cercano a la tension de circuito abierto
        Vs = Vx0:-0.1:0;                     % defino el vector de tensiones de las celulas 
    for H=1:length(mv)  %Para cada valor de parametros
        
        
        IL = Ilv(H) ;                        % Corriente luminosa
        Is = Isv(H);                         % Corriente de saturacion del primer diodo
        m  = mv(H);                          % Factor de idealidad del diodo
        Rs = Rsv(H);                         % Resistencia serie
        o=1;                                 % inicializo contador del vector de corrientes
        
        % calculo de la curva I-V
    
        for Vi = Vx0:-0.1:0     % para cada valor de tension...
        
            % metodo de Newton-Raphson 
            
             for t=1:max1
            
                Ix=Ix0-feval(@fVIdenmodulos,Vi,Ix0,IL,Is,m,Rs,Rp,vt,c)/feval(@dfVIdenmodulos,Vi,Ix0,IL,Is,m,Rs,Rp,vt,c);
                err=abs(Ix-Ix0);
                relerr=2*err/(abs(Ix)+ delta);
                Ix0=Ix;
                y=feval(@fVIdenmodulos,Vi,Ix0,IL,Is,m,Rs,Rp,vt,c);
                if (err<delta)|(relerr<delta)|(abs(y)<epsilon),break, end
            
             end
        
        I(H,o)=Ix;       % introduzco el valor de corriente obtenido en la posicion del vector de corrientes correspondiente
        V(H,:)=Vs;
        o=o+1;           % incremento el contador de corrientes
        end
    
    end