%PRIMERO CREAMOS EL VECTOR Tm.
%SEGUNDO CREAMOS EL VECTOR Numerodemodulo.

function medidas2STCju(nombre_seg,Nmedidaselemento,alfamodulo,betamodulo,gammamodulo,Pn,Ns,Np,Tm,Numerodemodulo,D)
%funcin que pasa todos los archivos de medidas a STC. 
%Crea un archivo excell para cada carpeta de medidas (campo: "nombre_seg")
%Crea una hoja dentro de ese archivo para cada elemento medido (p.ej. modulo)
%Campos de entrada de la funcin:(nombre_seg,Nmedidaselemento,alfamodulo,betamodulo,gammamodulo,Pn,Ns,Np,Tm,Numerodemodulo)
% nombre_seg: variable de texto (nombre de la carpeta del seguidor)
% Numerodemodulo: vector que recoge el numero de cada elemento segn el
% orden en el que se ha medido
% Nmedidaselemento: Es el numero de medidas tomadas por elemento.
% Tm: vector de temperaruras (en el orden de medida);
% alfamodulo: Coef. temp. de Isc en A/C con su signo  (POSITIVO)
% betamodulo: Coef. temp. de Voc  en V/C con su signo (NEGATIVO).
% gammamodulo: Coef. temp. de Pmax en %/C con su signo (NEGATIVO).
% Pn: Potencia nominal del mdulo (W).
% Ns: numero de modulos en serie del elemento medido (mdulo o conjunto de mdulos).
% Np: numero de modulos en paralelo del elemento medido (mdulo o conjunto de
% mdulos).

warning off
 % Caracteristicas nominales del generador.
 
alfagenerador=alfamodulo*Np; % en A/C.
betagenerador=betamodulo*Ns; % en V/C.
Pngen=Pn*Ns*Np; % en W.
ww=1;
% Obtenemos los valores medidos 

% Para cada archivo...

contador=1; % Indica la medida del elemento en la que estamos.

for i=1:length(D)              
    nombremodulo{i}=D(i).name; % Seleccionamos el archivo excel que queremos cargar
    [N, T]=xlsread(['C:\Users\usuario\Desktop\pfc\medidas de Mikel\Seguidores medidos\L14\',nombre_seg,'\',nombremodulo{i}]);% Obtenemos los datos del archivo excel anterior.
       % N es una matriz de 101x3 donde las columnas son respec : V,I,P.
       % T es una celda de strings donde el valor que nos interesa (Irrandiancia, Geff) est en la posicion (2,2). 
       
    Geff=str2num(T{2,2}); %Pasamos el valor de Geff a num porque era texto.
    Pmax_med=max(N(:,3)); %Valor de potencia mxima medida
    %Ya tenemos todo cargado comenzamos a pasar a STC.
    % Pasamos la tensin Voc a STC.
    Voc= N(end,1);
    VocSTC= Voc + betagenerador*(25 - Tm(i));
    incrementoV=VocSTC-Voc;
    
    % Pasamos la intensidad Isc a STC.
        
    Isc= N(1,2);
    IscSTC= Isc*1000/Geff + alfagenerador*(25 - Tm(i));
    incrementoI=IscSTC-Isc;
    
    % Pasamos V,I,P a STC.
    
    for j=1:size(N,1)
        
        MedidasSTC(j,1)=N(j,1)+incrementoV;
        MedidasSTC(j,2)=N(j,2)+incrementoI;                 
        MedidasSTC(j,3)=MedidasSTC(j,1)*MedidasSTC(j,2);
        
    end
    
    %calculamos pot max en STC.
    
    PmaxSTC1= max(MedidasSTC(:,3)); % Metodo 1 : Valor maximo del vector Potencia anterior (STC).
    PmaxSTC2= Pmax_med*1000/Geff/(1+gammamodulo*(Tm(i)-25)); % Metodo 2: Potencia mxima medida pasada a STC (con gamma)
    DifmetodosSTC=(PmaxSTC1-PmaxSTC2)/ max([PmaxSTC2, PmaxSTC1])*100; % Diferencia de ambos metodos en %.
   
    %creamos lo que va a ser nuestro excel.
    
    Elemento{contador}=N;
    ElementoSTC{contador}=MedidasSTC;
    PmaxElementoSTC(contador,1)= PmaxSTC1;
    PmaxElementoSTC(contador,2)= PmaxSTC2;
    PmaxElementoSTC(contador,3)= DifmetodosSTC;
    GeffElemento(contador)=Geff;
    TmElemento(contador)=Tm(i);
    
    % Incrementamos el contador porque pasamos a la siguiente medida del elemento
    
    contador=contador+1;    
    
    if mod(i,Nmedidaselemento)== 0
        
        contador=contador-1;
        
        % Valores medios del elemento.
               
        for n=1:contador
            
            TensionElementoSTC(:,n)=ElementoSTC{n}(:,1);
            CorrienteElementoSTC(:,n)=ElementoSTC{n}(:,2);
            PotenciaElementoSTC(:,n)=ElementoSTC{n}(:,3);
            
        end
        
        mediaElementoSTC(:,1)=mean(TensionElementoSTC')';
        mediaElementoSTC(:,2)=mean(CorrienteElementoSTC')';
        mediaElementoSTC(:,3)=mean(PotenciaElementoSTC')';
        mediaPmaxElementoSTC(1,:)=mean(PmaxElementoSTC);        
        
        % Dibujamos las Curvas medias VI (STC) del elemento.
       
        
       %LO HE QUITADO!!!!
       
       
        % Pasamos a excel.
        nombre_hoja=['Modulo',num2str(Numerodemodulo(i))];
        for n=1:contador
            
            matriz=Elemento{n};
            celda{1,1}='Tension (V)';
            celda{1,2}='Intensidad (A)';
            celda{1,3}='Potencia (W)';
            for s=1:size(matriz,1)
                celda{s+1,1}=matriz(s,1);
                celda{s+1,2}=matriz(s,2);
                celda{s+1,3}=matriz(s,3);
            end
            
            matrizSTC=ElementoSTC{n};
            celdaSTC{1,1}='Tension STC (V)';
            celdaSTC{1,2}='Intensidad STC (A)';
            celdaSTC{1,3}='Potencia STC (W)';
            for s1=1:size(matrizSTC,1)
                celdaSTC{s1+1,1}=matrizSTC(s1,1);
                celdaSTC{s1+1,2}=matrizSTC(s1,2);
                celdaSTC{s1+1,3}=matrizSTC(s1,3);
            end
                        
            
            VectorP=PmaxElementoSTC(n,:);
            celdaP{1,1}='Pmax  STC (Metodo 1)';
            celdaP{1,2}='Pmax  STC (Metodo 2)';
            celdaP{1,3}='Diferencia Metodos';
            celdaP{2,1}=VectorP(1,1);
            celdaP{2,2}=VectorP(1,2);
            celdaP{2,3}=VectorP(1,3);
        
            
            if n==1
                rango='A1';
                rangoSTC='D1';
                rangoP='D104';
            elseif n==2
                rango='H1';
                rangoSTC='K1';
                rangoP='K104';
            elseif n==3
                rango='O1';
                rangoSTC='R1';
                rangoP='R104';
            elseif n==4
                rango='V1';
                rangoSTC='Y1';
                rangoP='Y104';
            elseif n==5
                rango='AC1';
                rangoSTC='AF1';
                rangoP='AF104';
            end  
            
            %insertamos las medidas
            
            xlswrite(['C:\Users\usuario\Desktop\pfc\para matlab\DatosL14'],celda,nombre_hoja,rango);
            
            %insertamos las medidas pasadas a STC
            
            xlswrite(['C:\Users\usuario\Desktop\pfc\para matlab\DatosL14'],celdaSTC,nombre_hoja,rangoSTC);
            
            %insertamos las Potencias max (Dos metodos) pasadas a STC
            
            xlswrite(['C:\Users\usuario\Desktop\pfc\para matlab\DatosL14'],celdaP,nombre_hoja,rangoP);
     
        end
        
       %insertamos las medias.
       
        matrizmean=mediaElementoSTC;
        celdamean{1,1}='Medias Tension STC (V)';
        celdamean{1,2}='Medias Intensidad STC (A)';
        celdamean{1,3}='Medias Potencia STC (W)';
        for s2=1:size(mediaElementoSTC,1)
            celdamean{s2+1,1}=matrizmean(s2,1);
            celdamean{s2+1,2}=matrizmean(s2,2);
            celdamean{s2+1,3}=matrizmean(s2,3);
        end
        
        VectorPmean=mediaPmaxElementoSTC;
        celdaPmean{1,1}='Media Pmax  STC (Metodo 1)';
        celdaPmean{1,2}='Media Pmax  STC (Metodo 2)';
        celdaPmean{1,3}='Diferencia Metodos';
        celdaPmean{2,1}=VectorPmean(1,1);
        celdaPmean{2,2}=VectorPmean(1,2);
        celdaPmean{2,3}=VectorPmean(1,3);
        
        Pmaximas(ww,1)= max(matrizmean(:,3));
        ww=ww+1;
       
        if n==1
            rangomean='H1';
            rangoPmean='H104';
        elseif n==2
            rangomean='O1';
            rangoPmean='O104';
        elseif n==3
            rangomean='V1';
            rangoPmean='V104';
        elseif n==4
            rangomean='AC1';
            rangoPmean='AC104';
        elseif n==5
            rangomean='AJ1';
            rangoPmean='AJ104';
        end
        
        xlswrite(['C:\Users\usuario\Desktop\pfc\para matlab\DatosL14'],celdamean,nombre_hoja,rangomean);   
        xlswrite(['C:\Users\usuario\Desktop\pfc\para matlab\DatosL14'],celdaPmean,nombre_hoja,rangoPmean);  
          xlswrite(['C:\Users\usuario\Desktop\pfc\para matlab\DatosL14'],Pmaximas,'Pmax'); %LOS DATOS EN EXCEL ESTAN EN EL ORDEN DE ORDEN MODULOS(ejem,el uno es el dato del 28 ect.)
        
        contador=1;  %inicializamos el nmero de la medida a 1
        
    end
    
end
    
 
       